unit cawin32;

(*
Copyright (C) 1998 Paul Toth (TothPaul@Mygale.org)
 http://www.mygale.org/~tothpaul

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*)



// Client Access for windows 95 API reference
// by Paul TOTH <tothpaul@mygale.org>
// http://www.mygale.org/~tothpaul

// IBM online documentation at
// http://as400bks.rochester.ibm.com/cgi-bin/bookmgr/bookmgr.cmd/BOOKS/QBKACO00/CCONTENTS

// History (started 08/31/98)
// v1.0 - CWB.H, CWBSV.H -  8-31-98
//      - CWBDB.H        -  9-31-98
//      - CWBCO.H        -  9-31-98
//      - CWBRC.H        -  10-3-98

interface

uses
 windows;

//  --- CWB.H ---
(********************************************************************
// Common definitions                                                
//********************************************************************)
Type
 cwb_Handle     =dword;
 cwbSV_ErrHandle=cwb_Handle;
 cwb_Boolean    =boolean;
(********************************************************************
// Client Access/400 return codes fall into the following            
// categories:                                                       
// - Global return codes corresponding to operating system errors
// - Global return codes unique to Client Access/400                 
// - Specific return codes for each Client Access/400 function       
//                                                                   
// The global return codes are defined in this file.  The function   
// specific return codes are defined in the function specific        
// header files.                                                     
//********************************************************************)

(********************************************************************
// Global return codes corresponding to operating system errors      
//********************************************************************)
Const
   CWB_OK                         =0;
   CWB_INVALID_FUNCTION           =1;
   CWB_FILE_NOT_FOUND             =2;
   CWB_PATH_NOT_FOUND             =3;
   CWB_TOO_MANY_OPEN_FILES        =4;
   CWB_ACCESS_DENIED              =5;
   CWB_INVALID_HANDLE             =6;
   CWB_NOT_ENOUGH_MEMORY          =8;
   CWB_INVALID_DRIVE             =15;
   CWB_NO_MORE_FILES             =18;
   CWB_DRIVE_NOT_READY           =21;
   CWB_GENERAL_FAILURE           =31;
   CWB_SHARING_VIOLATION         =32;
   CWB_LOCK_VIOLATION            =33;
   CWB_END_OF_FILE               =38;
   CWB_NOT_SUPPORTED             =50;
   CWB_BAD_NETWORK_PATH          =53;
   CWB_NETWORK_BUSY              =54;
   CWB_DEVICE_NOT_EXIST          =55;
   CWB_UNEXPECTED_NETWORK_ERROR  =59;
   CWB_NETWORK_ACCESS_DENIED     =65;
   CWB_FILE_EXISTS               =80;
   CWB_ALREADY_ASSIGNED          =85;
   CWB_INVALID_PARAMETER         =87;
   CWB_NETWORK_WRITE_FAULT       =88;
   CWB_OPEN_FAILED              =110;
   CWB_BUFFER_OVERFLOW          =111;
   CWB_DISK_FULL                =112;
   CWB_PROTECTION_VIOLATION     =115;
   CWB_INVALID_LEVEL            =124;
   CWB_BUSY_DRIVE               =142;
   CWB_INVALID_FSD_NAME         =252;
   CWB_INVALID_PATH             =253;

(********************************************************************
// Global return codes unique to Client Access/400                   
//********************************************************************)
   CWB_START   =4000;
   CWB_LAST    =5999;

   CWB_USER_CANCELLED_COMMAND          =CWB_START;
   CWB_CONFIG_ERROR                    =CWB_START+1;
   CWB_LICENSE_ERROR                   =CWB_START+2;
   CWB_PROD_OR_COMP_NOT_SET            =CWB_START+3;
   CWB_SECURITY_ERROR                  =CWB_START+4;
   CWB_GLOBAL_CFG_FAILED               =CWB_START+5;
   CWB_PROD_RETRIEVE_FAILED            =CWB_START+6;
   CWB_COMP_RETRIEVE_FAILED            =CWB_START+7;
   CWB_COMP_CFG_FAILED                 =CWB_START+8;
   CWB_COMP_FIX_LEVEL_UPDATE_FAILED    =CWB_START+9;
   CWB_INVALID_API_HANDLE              =CWB_START+10;
   CWB_INVALID_API_PARAMETER           =CWB_START+11;
   CWB_HOST_NOT_FOUND                  =CWB_START+12;
   CWB_NOT_COMPATIBLE                  =CWB_START+13;
   CWB_INVALID_POINTER                 =CWB_START+14;
   CWB_SERVER_PROGRAM_NOT_FOUND        =CWB_START+15;
   CWB_API_ERROR                       =CWB_START+16;
   CWB_CA_NOT_STARTED                  =CWB_START+17;
   CWB_FILE_IO_ERROR                   =CWB_START+18;
   CWB_COMMUNICATIONS_ERROR            =CWB_START+19;
   CWB_RUNTIME_CONSTRUCTOR_FAILED      =CWB_START+20;
   CWB_DIAGNOSTIC                      =CWB_START+21;
   CWB_COMM_VERSION_ERROR              =CWB_START+22;
   CWB_NO_VIEWER                       =CWB_START+23;
   CWB_MODULE_NOT_LOADABLE             =CWB_START+24;
   CWB_ALREADY_SETUP                   =CWB_START+25;
   CWB_CANNOT_START_PROCESS            =CWB_START+26;
   CWB_NON_REPRESENTABLE_UNICODE_CHAR  =CWB_START+27;

// --- CWBSV.H ---
(*------------------------------------------------------------------
// TYPEDEFS:
//------------------------------------------------------------------*)
type
 cwbSV_MessageTextHandle= cwb_Handle;
 cwbSV_TraceDataHandle  = cwb_Handle;
 cwbSV_TraceAPIHandle   = cwb_Handle;
 cwbSV_TraceSPIHandle   = cwb_Handle;
 cwbSV_ServiceFileHandle= cwb_Handle;
 cwbSV_ServiceRecHandle = cwb_Handle;

 cwbSV_ServiceFileType= dword;
 cwbSV_ServiceRecType = dword;
 cwbSV_EventType      = dword;
 cwbSV_ProblemType    = dword;
 cwbSV_CreatedBy      = dword;
 cwbSV_ProblemSeverity= dword;
 cwbSV_ProblemStatus  = dword;

(*------------------------------------------------------------------
// DEFINES: for cwbSV_ServiceFileType
//------------------------------------------------------------------*)
const
 CWBSV_HISTORY_LOG = 0;
 CWBSV_PROBLEM_LOG = 1;
 CWBSV_DETAIL_TRACE_FILE = 2;
 CWBSV_ENTRY_EXIT_TRACE_FILE = 3;

(*------------------------------------------------------------------
// DEFINES: for cwbSV_ServiceRecType                                
//------------------------------------------------------------------*)
 CWBSV_MESSAGE_REC     =0;
 CWBSV_PROBLEM_REC     =1;
 CWBSV_DATA_TRACE_REC  =2;
 CWBSV_API_TRACE_REC   =3;
 CWBSV_SPI_TRACE_REC   =4;

(*------------------------------------------------------------------
// DEFINES: for cwbSV_EventType                                     
//------------------------------------------------------------------*)
 CWBSV_ENTRY_POINT  =0;
 CWBSV_EXIT_POINT   =1;

(*------------------------------------------------------------------
// DEFINES: for cwbSV_ProblemType                                   
//------------------------------------------------------------------*)
 CWBSV_APP_DETECTED   =0;
 CWBSV_USER_DETECTED  =1;

(*------------------------------------------------------------------
// DEFINES: for cwbSV_CreatedBy                                     
//------------------------------------------------------------------*)
 CWBSV_OWNER_CLIENTACCESS  ='P';

(*------------------------------------------------------------------
// DEFINES: for cwbSV_ProblemSeverity                               
//------------------------------------------------------------------*)
 CWBSV_SEV_HIGH    =1;
 CWBSV_SEV_MEDIUM  =2;
 CWBSV_SEV_LOW     =3;
 CWBSV_SEV_NONE    =4;

(*------------------------------------------------------------------
// DEFINES: for cwbSV_ProblemStatus                                 
//------------------------------------------------------------------*)
 CWBSV_STATUS_READY  ='R';
 CWBSV_STATUS_SENT   ='S';

(*------------------------------------------------------------------
// DEFINES: for error class                                         
//------------------------------------------------------------------*)
 CWBSV_CLASS_INFORMATIONAL   =0;
 CWBSV_CLASS_ERROR_RETRY     =1;
 CWBSV_CLASS_ERROR_ABORT     =2;

(*------------------------------------------------------------------
// DEFINES: for maximum string lengths                              
//------------------------------------------------------------------*)
 CWBSV_MAX_FILE_PATH         =260;  // Service file path

 CWBSV_MAX_PRODUCT_ID       =32+1;  // Service Rec: Product ID
 CWBSV_MAX_COMP_ID          =32+1;  // Service Rec: Component ID
 CWBSV_MAX_DATE_VALUE       =24+1;  // Service Rec: Date (locale format)
 CWBSV_MAX_TIME_VALUE       =24+1;  // Service Rec: Time (locale format)

 CWBSV_MAX_PROBLEM_ID       =10+1;  // Problem Rec: Problem ID
 CWBSV_MAX_PROBLEM_TEXT     = 7+1;  // Problem Rec: Problem text
 CWBSV_MAX_FAIL_PRODUCT_ID  =64+1;  // Problem Rec: Failing product ID
 CWBSV_MAX_FAIL_VERSION     =64+1;  // Problem Rec: Failing version
 CWBSV_MAX_CURRENT_FIX      = 8+1;  // Problem Rec: Current fix level
 CWBSV_MAX_PREVIOUS_FIX     = 8+1;  // Problem Rec: Previous fix level
 CWBSV_MAX_FAIL_PATH      =1024+1;  // Problem Rec: Failing path
 CWBSV_MAX_FAIL_MODULE      =64+1;  // Problem Rec: Failing module name
 CWBSV_MAX_FAIL_METHOD      =32+1;  // Problem Rec: Failing method name
 CWBSV_MAX_SYMPTOM_STRING  =256+1;  // Problem Rec: Symptom string
 CWBSV_MAX_ORIGIN_SYS_ID   =256+1;  // Problem Rec: Origin system ID
 CWBSV_MAX_ORIGIN_IP_ADDR   =15+1;  // Problem Rec: Origin IP address

(*------------------------------------------------------------------*/
/* DEFINES: CWBSV.H specific return codes                           */
/*------------------------------------------------------------------*)
 CWBSV_START = CWB_LAST+1;         // CWB_LAST defined in CWB.H

 CWBSV_INVALID_FILE_TYPE        =CWBSV_START;
 CWBSV_INVALID_RECORD_TYPE      =CWBSV_START+1;
 CWBSV_INVALID_EVENT_TYPE       =CWBSV_START+2;
 CWBSV_NO_ERROR_MESSAGES        =CWBSV_START+3;

(********************************************************************/
/*   Clears the service file identified by the handle provided.     */
/********************************************************************)
function cwbSV_ClearServiceFile(serviceFile:cwbSV_ServiceFileHandle;
                                errorHandle:cwbSV_ErrHandle):integer; stdcall;
(********************************************************************/
/*   Closes the service file identified by the handle provided.     */
/********************************************************************)
function cwbSV_CloseServiceFile(serviceFile:cwbSV_ServiceFileHandle;
                                errorHandle:cwbSV_ErrHandle):integer; stdcall;
(********************************************************************/
/*   This function creates an error message object and returns a    */
/*   handle to it. This error handle can be passed to Client        */
/*   Access/400 API's that support it. If an error occurs on one    */
/*   of these API's, the error handle can be used to retrieve the   */
/*   error messages text associated with the API error.             */
/********************************************************************)
function cwbSV_CreateErrHandle(Var errorHandle:cwbSV_ErrHandle):integer; stdcall;

(********************************************************************/
/*   This function creates a message text object and returns a      */
/*   handle to it. This message handle can be used in your program  */
/*   to write message text to the currently active history log.     */
/*   The message text is supplied in a buffer passed on the         */
/*   cwbSV_LogMessageText() call.                                   */
/********************************************************************)
function cwbSV_CreateMessageTextHandle(var productID,componentID:pchar;
                                       var messageTextHandle:cwbSV_MessageTextHandle):integer; stdcall;

(********************************************************************/
/*   This function creates a service record object and returns a    */
/*   handle to it.                                                  */
/********************************************************************)
function cwbSV_CreateServiceRecHandle(serviceRecHandle:cwbSV_ServiceRecHandle):integer; stdcall;

(********************************************************************/
/*   This function creates a trace API object and returns a handle  */
/*   to it. This trace API handle can be used in your program to    */
/*   log entry to and exit from your API entry points.              */
/********************************************************************)
function cwbSV_CreateTraceAPIHandle(productID,coponentID:pchar;
                                    var traceAPIHandle:cwbSV_TraceAPIHandle):integer; stdcall;

(********************************************************************/
/*   This function creates a trace data object and returns a        */
/*   handle to it. This trace handle can be used in your program to */
/*   log trace information to trace files. The trace information is */
/*   supplied in a buffer passed on cwbSV_LogTraceData() calls.     */
/********************************************************************)
function cwbSV_CreateTraceDataHandle(productID,componentID:pchar;
                                     var traceDataHandle:cwbSV_TraceDataHandle):integer; stdcall;

(********************************************************************/
/*   This function creates a trace SPI object and returns a handle  */
/*   to it. This trace SPI handle can be used in your program to    */
/*   log entry to and exit from your SPI entry points.              */
/********************************************************************)
function cwbSV_CreateTraceSPIHandle(productID,componentID:pchar;
                                    var traceSPIHandle:cwbSV_TraceSPIHandle):integer; stdcall;

(********************************************************************/
/*   This function deletes the error message object that is         */
/*   identified by the handle provided.                             */
/********************************************************************)
function cwbSV_DeleteErrHandle(errorHandle:cwbSV_ErrHandle):integer; stdcall;

(********************************************************************/
/*   This function deletes the message text object that is          */
/*   identified by the handle that is provided.                     */
/********************************************************************)
function cwbSV_DeleteMessageTextHandle(messageTextHandle:cwbSV_MessageTextHandle):integer; stdcall;

(********************************************************************/
/*   This function deletes the service record object that is        */
/*   identified by the handle provided.                             */
/********************************************************************)
function cwbSV_DeleteServiceRecHandle(serviceRecHandle:cwbSV_ServiceRecHandle):integer; stdcall;

(********************************************************************/
/*   This function deletes the trace API object that is             */
/*   identified by the handle that is provided.                     */
/********************************************************************)
function cwbSV_DeleteTraceAPIHandle(traceAPIHandle:cwbSV_TraceAPIHandle):integer; stdcall;

(********************************************************************/
/*   This function deletes the trace data object that is            */
/*   identified by the trace handle provided.                       */
/********************************************************************)
function cwbSV_DeleteTraceDataHandle(traceDataHandle:cwbSV_TraceDataHandle):integer; stdcall;

(********************************************************************/
/*   This function deletes the trace SPI object that is             */
/*   identified by the handle that is provided.                     */
/********************************************************************)
function cwbSV_DeleteTraceSPIHandle(traceSPIHandle:cwbSV_TraceAPIHandle):integer; stdcall;

(********************************************************************/
/*   Returns the component ID value for the service record object   */
/*   identified by the handle provided.                             */
/********************************************************************)
function cwbSV_GetComponent(serviceRecHandle:cwbSV_ServiceRecHandle;
                          componentID:pchar;
                          componentIDLength:dword;
                          var returnLength:dword):integer; stdcall;

(********************************************************************/
/*   Returns the created by indicator for the service record object */
/*   identified by the handle provided.                             */
/********************************************************************)
function cwbSV_GetCreatedBy(serviceRecHandle:cwbSV_ServiceRecHandle; var createdBy:cwbSV_CreatedBy):integer; stdcall;

(********************************************************************/
/*   Returns the current fix level string for the service record    */
/*   identified by the handle provided.                             */
/********************************************************************)
function cwbSV_GetCurrentFix(serviceRecHandle:cwbSV_ServiceRecHandle;
                     currentFix:pchar;
                     currentFixLength:dword;
                     var returnLength:dword):integer; stdcall;

(********************************************************************/
/*   Returns the datestamp (in localized format) for the service    */
/*   record identified by the handle provided.                      */
/********************************************************************)
function cwbSV_GetDateStamp(serviceRecHandle:cwbSV_ServiceRecHandle;
                    var dateStemp:pchar;
                    dateStampLength:dword;
                    var returnLength:dword):integer; stdcall;

(********************************************************************/
/*   Returns the message class associated with the top-level        */
/*   (e.g. most recent) error identified by the error handle        */
/*   provided.                                                      */
/********************************************************************)
function cwbSV_GetErrClass(errorHandle:cwbSV_ErrHandle; var errorClass:dword):integer; stdcall;

(********************************************************************/
/*   Returns the message class associated with the error index      */
/*   provided. An index value of 1 will retrieve the lowest-level   */
/*   (e.g. oldest) message associated with the error handle. An     */
/*   index value of "cwbSV_GetErrCount()'s returned errorCount"     */
/*   will retrieve the the top-level (e.g. most recent) message     */
/*   associated with the error handle.                              */
/********************************************************************)
function cwbSV_GetErrClassIndexed(errorHandle:cwbSV_ErrHandle;errorIndex:dword;var errorClass:dword):integer; stdcall;

(********************************************************************/
/*   Returns the number of messages associated with the error       */
/*   handle provided.                                               */
/********************************************************************)
function cwbSV_GetErrCount(errorHandle:cwbSV_ErrHandle; var errorCount:dword):integer; stdcall;

(********************************************************************/
/*   Returns the message text associated with the top-level         */
/*   (e.g. most recent) error identified by the error handle        */
/*   provided.                                                      */
/********************************************************************)
function cwbSV_GetErrText(errorHandle:cwbSV_ErrHandle;
                            errorText:PChar;
                            errorTextLength:dword;
                            var returnLength:dword):integer; stdcall;

(********************************************************************/
/*   Returns the message text associated with the error index       */
/*   provided. An index value of 1 will retrieve the lowest-level   */
/*   (e.g. oldest) message associated with the error handle. An     */
/*   index value of "cwbSV_GetErrCount()'s returned errorCount"     */
/*   will retrieve the the top-level (e.g. most recent) message     */
/*   associated with the error handle.                              */
/********************************************************************)
function cwbSV_GetErrTextIndexed(errorHandle:cwbSV_ErrHandle;
                            errorIndex:dword;
                            errorText:pchar;
                            errorTextLength:dword;
                            var returnLength:dword):integer; stdcall;

(********************************************************************/
/*   Returns the name of failing method or routine for the service  */
/*   record identified by the handle provided.                      */
/********************************************************************)
function cwbSV_GetFailMethod(serviceRecHandle:cwbSV_ServiceRecHandle;
                         failMethod:pchar;
                         failMethodLength:dword;
                         var returnLength:dword):integer; stdcall;

(********************************************************************/
/*   Returns the name of failing module for the service record      */
/*   identified by the handle provided.                             */
/********************************************************************)
function cwbSV_GetFailModule(serviceRecHandle:cwbSV_ServiceRecHandle;
                       failModule:pchar;
                       failModuleLength:dword;
                       var returnLength:dword):integer; stdcall;

(********************************************************************/
/*   Returns the path of failing component for the service record   */
/*   identified by the handle provided.                             */
/********************************************************************)
function cwbSV_GetFailPathName(serviceRecHandle:cwbSV_ServiceRecHandle;
                          failPath:pchar;
                          failPathLength:dword;
                          var returnLength:dword):integer; stdcall;

(********************************************************************/
/*   Returns the failing product ID string for the service record   */
/*   identified by the handle provided.                             */
/********************************************************************)
function cwbSV_GetFailProductID(serviceRecHandle:cwbSV_ServiceRecHandle;
                           failProductID:pchar;
                           failProductIDLength:dword;
                           var returnLength:dword):integer; stdcall;

(********************************************************************/
/*   Returns the failing version string for the service record      */
/*   identified by the handle provided.                             */
/********************************************************************)
function cwbSV_GetFailVersion(serviceRecHandle:cwbSV_ServiceRecHandle;
                         failVersion:pchar;
                         failVersionLength:dword;
                         var returnLength:dword):integer; stdcall;

(********************************************************************/
/*   Returns the size (in bytes) of the largest record in the       */
/*   service file identified by the file handle provided.           */
/********************************************************************)
function cwbSV_GetMaxRecordSize(serviceFile:cwbSV_ServiceFileHandle; var maxRecordSize:dword):integer; stdcall;

(********************************************************************/
/*   Returns the message text portion of the service record object  */
/*   identified by the handle provided.                             */
/********************************************************************)
function cwbSV_GetMessageText(serviceRecHandle:cwbSV_ServiceRecHandle;
                           messageText:pchar;
                           messageTextLength:dword;
                           var returnLength:dword):integer; stdcall;

(********************************************************************)
(*   Returns the origin system ID string for the service record     *)
(*   identified by the handle provided.                             *)
(********************************************************************)
function cwbSV_GetOriginSystemID(serviceRecHandle:cwbSV_ServiceRecHandle;
                                 originSystemID:pchar;
                                 originSystemIDLength:dword;
                                 var returnLength:dword):integer; stdcall;

(********************************************************************)
(*   Returns the origin system IP address for the service record    *)
(*   identified by the handle provided.                             *)
(********************************************************************)
function cwbSV_GetOriginSystemIPAddr(
                             serviceRecHandle:cwbSV_ServiceRecHandle;
                             originIPAddr:pchar;
                             originIPAddrLength:word;
                             returnLength:dword):integer; stdcall;

(********************************************************************)
(*   Returns the previous fix level string for the service record   *)
(*   identified by the handle provided.                             *)
(********************************************************************)
function cwbSV_GetPreviousFix(
                             serviceRecHandle:cwbSV_ServiceRecHandle;
                             previousFix:pchar;
                             previousFixLength:dword;
                             var returnLength:dword):integer; stdcall;

(********************************************************************)
(*   Returns the problem string value for the service record object *)
(*   identified by the handle provided.                             *)
(********************************************************************)
function cwbSV_GetProblemID(
                             serviceRecHandle:cwbSV_ServiceRecHandle;
                             problemID:pchar;
                             problemIDLength:dword;
                             var returnLength:dword):integer; stdcall;

(********************************************************************)
(*   Returns the problem status for the service record object       *)
(*   identified by the handle provided.                             *)
(********************************************************************)
function cwbSV_GetProblemStatus(
                             serviceRecHandle:cwbSV_ServiceRecHandle;
                             var problemStatus:cwbSV_ProblemStatus):integer; stdcall;

(********************************************************************)
(*   Returns the problem text string for the service record object  *)
(*   identified by the handle provided.                             *)
(********************************************************************)
function cwbSV_GetProblemText(
                             serviceRecHandle:cwbSV_ServiceRecHandle;
                             problemText:pchar;
                             problemTextLength:dword;
                             var returnLength:dword):integer; stdcall;

(********************************************************************)
(*   Returns the problem type for the service record object         *)
(*   identified by the handle provided.                             *)
(********************************************************************)
function cwbSV_GetProblemType(
                             serviceRecHandle:cwbSV_ServiceRecHandle;
                             var problemType:cwbSV_ProblemType):integer; stdcall;

(********************************************************************)
(*   Returns the product ID value for the service record object     *)
(*   identified by the handle provided.                             *)
(********************************************************************)
function cwbSV_GetProduct(
                             serviceRecHandle:cwbSV_ServiceRecHandle;
                             productID:pchar;
                             productIDLength:dword;
                             var returnLength:dword):integer; stdcall;

(********************************************************************)
(*   Returns the total numbers of records in the service file       *)
(*   identified by the file handle provided.                        *)
(********************************************************************)
function cwbSV_GetRecordCount(
                             serviceFile:cwbSV_ServiceFileHandle;
                             var recordCount:dword):integer; stdcall;

(********************************************************************)
(*   Returns the fully-qualified path and file name of where        *)
(*   the service records are being logged to for a particular       *)
(*   file type.                                                     *)
(********************************************************************)
function cwbSV_GetServiceFileName(
                             serviceFileType:cwbSV_ServiceFileType;
                             fileName:pchar;
                             fileNameLength:dword;
                             var returnLength:dword):integer; stdcall;

(********************************************************************)
(*   Returns the type of record (trace, message, entry/exit, etc..) *)
(*   for the service record identified by the handle provided.      *)
(*                                                                  *)
(*   Note: The service record needs to be filled in by a call to    *)
(*         a "read" function before calling this function.          *)
(********************************************************************)
function cwbSV_GetServiceType(
                             serviceRecHandle:cwbSV_ServiceRecHandle;
                             var serviceType:cwbSV_ServiceRecType;
                             errorHandle:cwbSV_ErrHandle):integer; stdcall;

(********************************************************************)
(*   Returns the problem severity for the service record object     *)
(*   identified by the handle provided.                             *)
(********************************************************************)
function cwbSV_GetSeverity(
                             serviceRecHandle:cwbSV_ServiceRecHandle;
                             var severity:cwbSV_ProblemSeverity):integer; stdcall;

(********************************************************************)
(*   Returns the symptom string for the service record identified   *)
(*   by the handle provided.                                        *)
(********************************************************************)
function cwbSV_GetSymptomString(
                             serviceRecHandle:cwbSV_ServiceRecHandle;
                             symptomString:pchar;
                             symptomStringLength:dword;
                             var returnLength:dword):integer; stdcall;

(********************************************************************)
(*   Returns the timestamp (in localized format) for the service    *)
(*   record identified by the handle provided.                      *)
(********************************************************************)
function cwbSV_GetTimeStamp(
                             serviceRecHandle:cwbSV_ServiceRecHandle;
                             timeStamp:pchar;
                             timeStampLength:dword;
                             var returnLength:dword):integer; stdcall;

(********************************************************************)
(*   Returns the API trace data portion of the service record       *)
(*   identified by the handle provided.                             *)
(********************************************************************)
function cwbSV_GetTraceAPIData(
                             serviceRecHandle:cwbSV_ServiceRecHandle;
                             apiData:pchar;
                             apiDataLength:dword;
                             var returnLength:dword):integer; stdcall;

(********************************************************************)
(*   Returns the API event ID of the service record object          *)
(*   identified by the handle provided.                             *)
(********************************************************************)
function cwbSV_GetTraceAPIID(
                             serviceRecHandle:cwbSV_ServiceRecHandle;
                             apiID:pchar):integer; stdcall;

(********************************************************************)
(*   Returns the API event type of the service record object        *)
(*   identified by the handle provided.                             *)
(********************************************************************)
function cwbSV_GetTraceAPIType(
                             serviceRecHandle:cwbSV_ServiceRecHandle;
                             var eventType:cwbSV_EventType;
                             errorHandle:cwbSV_ErrHandle):integer; stdcall;

(********************************************************************)
(*   Returns the trace data portion of the service record object    *)
(*   identified by the handle provided.                             *)
(********************************************************************)
function cwbSV_GetTraceData(
                             serviceRecHandle:cwbSV_ServiceRecHandle;
                             traceData:pchar;
                             traceDataLength:dword;
                             var returnLength:dword):integer; stdcall;

(********************************************************************)
(*   Returns the SPI trace data portion of the service record       *)
(*   identified by the handle provided.                             *)
(********************************************************************)
function cwbSV_GetTraceSPIData(
                             serviceRecHandle:cwbSV_ServiceRecHandle;
                             spiData:pchar;
                             spiDataLength:dword;
                             var returnLength:dword):integer; stdcall;

(********************************************************************)
(*   Returns the SPI event ID of the service record object          *)
(*   identified by the handle provided.                             *)
(********************************************************************)
function cwbSV_GetTraceSPIID(
                             serviceRecHandle:cwbSV_ServiceRecHandle;
                             spiID:pchar):integer; stdcall;

(********************************************************************)
(*   Returns the SPI event type of the service record object        *)
(*   identified by the handle provided.                             *)
(********************************************************************)
function cwbSV_GetTraceSPIType(
                             serviceRecHandle:cwbSV_ServiceRecHandle;
                             var eventType:cwbSV_EventType;
                             errorHandle:cwbSV_ErrHandle):integer; stdcall;

(********************************************************************)
(*   This function will log an API entry point to the currently     *)
(*   active entry/exit trace file. The product and component ID's   *)
(*   set in the entry will be written along with the date and time  *)
(*   of the when the data was logged. The apiID along with any      *)
(*   optional data passed on the request will also be logged.       *)
(********************************************************************)
function cwbSV_LogAPIEntry(
                             traceAPIHandle:cwbSV_TraceAPIHandle;
                             apiID:char;
                             apiData:pchar;
                             apiDataLength:word):integer; stdcall;

(********************************************************************)
(*   This function will log an API exit point to the currently      *)
(*   active entry/exit trace file. The product and component ID's   *)
(*   set in the entry will be written along with the date and time  *)
(*   of the when the data was logged. The API ID along with any     *)
(*   optional data passed on the request will also be logged.       *)
(********************************************************************)
function cwbSV_LogAPIExit(
                             traceAPIHandle:cwbSV_TraceAPIHandle;
                             apiID:char;
                             apiData:pchar;
                             apiDataLength:dword):integer; stdcall;

(********************************************************************)
(*   This function will log the supplied message text to the        *)
(*   currently active history log. The product and component ID's   *)
(*   set in the entry will be written along with the date and time  *)
(*   of the when the text was logged.                               *)
(********************************************************************)
function cwbSV_LogMessageText(
                             messageTextHandle:cwbSV_MessageTextHandle;
                             messageText:pchar;
                             messageTextLength:dword):integer; stdcall;

(********************************************************************)
(*   This function will log an SPI entry point to the currently     *)
(*   active entry/exit trace file. The product and component ID's   *)
(*   set in the entry will be written along with the date and time  *)
(*   of the when the data was logged. The spiID along with any      *)
(*   optional data passed on the request will also be logged.       *)
(********************************************************************)
function cwbSV_LogSPIEntry(
                             traceSPIHandle:cwbSV_TraceSPIHandle;
                             spiID:char;
                             spiData:pchar;
                             spiDataLength:dword):integer; stdcall;

(********************************************************************)
(*   This function will log an SPI exit point to the currently      *)
(*   active entry/exit trace file. The product and component ID's   *)
(*   set in the entry will be written along with the date and time  *)
(*   of the when the data was logged. The spiID along with any      *)
(*   optional data passed on the request will also be logged.       *)
(********************************************************************)
function cwbSV_LogSPIExit(
                       traceSPIHandle:cwbSV_TraceSPIHandle;
                       spiID:char;
                       spiData:pchar;
                       spiDataLength:dword):integer; stdcall;

(********************************************************************)
(*   This function will log the supplied trace data to the          *)
(*   currently active trace file. The product and component ID's    *)
(*   set in the entry will be written along with the date and time  *)
(*   of the when the data was logged.                               *)
(********************************************************************)
function cwbSV_LogTraceData(
                             traceDataHandle:cwbSV_TraceDataHandle;
                             traceData:pchar;
                             traceDataLength:dword):integer; stdcall;

(********************************************************************)
(*   Opens the specified service file for READ access (history log, *)
(*   trace file, etc..) and returns a handle to it.                 *)
(********************************************************************)
function cwbSV_OpenServiceFile(
                             serviceFileName:pchar;
                             var serviceFileHandle:cwbSV_ServiceFileHandle;
                             errorHandle:cwbSV_ErrHandle):integer; stdcall;

(********************************************************************)
(*   Reads the newest record in the service file into the record    *)
(*   handle provided. Subsequent calls can be made to retrieve      *)
(*   the information stored in this record (e.g. GetProduct(),      *)
(*   GetDateStamp(), etc...).                                       *)
(*                                                                  *)
(*   Note: This record is the one with the newest time and          *)
(*         date stamp in the file.                                  *)
(********************************************************************)
function cwbSV_ReadNewestRecord(
                             serviceFileHandle:cwbSV_ServiceFileHandle;
                             serviceRecHandle:cwbSV_ServiceRecHandle;
                             errorHandle:cwbSV_ErrHandle):integer; stdcall;
(********************************************************************)
(*   Reads the oldest record in the service file into the record    *)
(*   handle provided. Subsequent calls can be made to retrieve      *)
(*   the information stored in this record (e.g. GetProduct(),      *)
(*   GetDateStamp(), etc...).                                       *)
(*                                                                  *)
(*   Note: This record is the one with the oldest time and          *)
(*         date stamp in the file.                                  *)
(********************************************************************)
function cwbSV_ReadOldestRecord(
                             serviceFileHandle:cwbSV_ServiceFileHandle;
                             serviceRecHandle:cwbSV_ServiceRecHandle;
                             errorHandle:cwbSV_errHandle):integer; stdcall;
(********************************************************************)
(*   Reads the previous record in the service file into the record  *)
(*   handle provided. Subsequent calls can be made to retrieve      *)
(*   the information stored in this record (e.g. GetProduct(),      *)
(*   GetDateStamp(), etc...).                                       *)
(********************************************************************)
function cwbSV_ReadPrevRecord(
                             serviceFileHandle:cwbSV_ServiceFileHandle;
                             serviceRecHandle:cwbSV_ServiceRecHandle;
                             errorHandle:cwbSV_errHandle):integer; stdcall;
(********************************************************************)
(*   This function allows setting of a unique component identifier  *)
(*   in the message handle provided. Along with setting the         *)
(*   product ID (see cwbSV_SetMessageProduct), this call should     *)
(*   be used to distinguish your message entries from other         *)
(*   product's entries in the history log.                          *)
(********************************************************************)
function cwbSV_SetMessageComponent(
                             messageTextHandle:cwbSV_MessageTextHandle;
                             componentID:pchar):integer; stdcall;

(********************************************************************)
(*   This function allows setting of a unique product identifier in *)
(*   the message handle provided. Along with setting the component  *)
(*   ID (see cwbSV_SetMessageComponent), this call should be used   *)
(*   to distinguish your message entries from other product's       *)
(*   entries in the history log.                                    *)
(********************************************************************)
function cwbSV_SetMessageProduct(
                             messageTextHandle:cwbSV_MessageTextHandle;
                             productID:pchar):integer; stdcall;

(********************************************************************)
(*   This function allows setting of a unique component identifier  *)
(*   in trace entry provided. Along with setting the product        *)
(*   ID (see cwbSV_SetAPIProduct), this call should be used to      *)
(*   distinguish your trace entries from other product's entries in *)
(*   the trace file.                                                *)
(********************************************************************)
function cwbSV_SetAPIComponent(
                             traceAPIHandle:cwbSV_TraceAPIHandle;
                             componentID:pchar):integer; stdcall;

(********************************************************************)
(*   This function allows setting of a unique product identifier in *)
(*   the trace handle provided. Along with setting the component    *)
(*   ID (see cwbSV_SetAPIComponent), this call should be used to    *)
(*   distinguish your trace entries from other product's entries in *)
(*   the trace file.                                                *)
(********************************************************************)
function cwbSV_SetAPIProduct(
                             traceAPIHandle:cwbSV_TraceAPIHandle;
                             productID:pchar):integer; stdcall;

(********************************************************************)
(*   This function allows setting of a unique component identifier  *)
(*   in trace entry provided. Along with setting the product        *)
(*   ID (see cwbSV_SetSPIProduct), this call should be used to      *)
(*   distinguish your trace entries from other product's entries in *)
(*   the trace file.                                                *)
(********************************************************************)
function cwbSV_SetSPIComponent(
                             traceSPIHandle:cwbSV_TraceSPIHandle;
                             componentID:pchar):integer; stdcall;

(********************************************************************)
(*   This function allows setting of a unique product identifier in *)
(*   the trace handle provided. Along with setting the component    *)
(*   ID (see cwbSV_SetSPIComponent), this call should be used to    *)
(*   distinguish your trace entries from other product's entries in *)
(*   the trace file.                                                *)
(********************************************************************)
function cwbSV_SetSPIProduct(
                             traceSPIHandle:cwbSV_TraceSPIHandle;
                             productID:pchar):integer; stdcall;

(********************************************************************)
(*   This function allows setting of a unique component identifier  *)
(*   in service entry provided. Along with setting the product      *)
(*   ID (see cwbSV_SetTraceProduct), this call should be used to    *)
(*   distinguish your trace entries from other product's entries in *)
(*   the trace file.                                                *)
(********************************************************************)
function cwbSV_SetTraceComponent(
                             traceDataHandle:cwbSV_TraceDataHandle;
                             componentID:pchar):integer; stdcall;

(********************************************************************)
(*   This function allows setting of a unique product identifier in *)
(*   the trace handle provided. Along with setting the component    *)
(*   ID (see cwbSV_SetTraceComponent), this call should be used to  *)
(*   distinguish your trace entries from other product's entries in *)
(*   the trace file.                                                *)
(********************************************************************)
function cwbSV_SetTraceProduct(
                             traceDataHandle:cwbSV_TraceDataHandle;
                             productID:pchar):integer; stdcall;

//--- CWBDB.H ---
const
 CWBDB_START                          =CWB_LAST+1;

(*------------------------------------------------------------------*)
(* An error was encountered which prevented the Data Access server  *)
(* from being started.                                              *)
(*------------------------------------------------------------------*)
 CWBDB_CANNOT_CONTACT_SERVER          =CWBDB_START+1;

(*------------------------------------------------------------------*)
(* An error was encountered during attempt to set the Data Access   *)
(* server attributes.                                               *)
(*------------------------------------------------------------------*)
 CWBDB_ATTRIBUTES_FAILURE             =CWBDB_START+2;

(*------------------------------------------------------------------*)
(* An attempt to start the Data Access server was made while a valid*)
(* server was running. Stop the server before restarting it.        *)
(*------------------------------------------------------------------*)
 CWBDB_SERVER_ALREADY_STARTED         =CWBDB_START+3;

(*------------------------------------------------------------------*)
(* The valid submitted for the DRDA package size was invalid.       *)
(*------------------------------------------------------------------*)
 CWBDB_INVALID_DRDA_PKG_SIZE         =CWBDB_START+4;

(*------------------------------------------------------------------*)
(* A memory allocation attempt by a request handle failed.          *)
(*------------------------------------------------------------------*)
 CWBDB_REQUEST_MEMORY_ALLOCATION_FAILURE=CWBDB_START+5;

(*------------------------------------------------------------------*)
(* A Request handle failed in an attempt to convert data.           *)
(*------------------------------------------------------------------*)
 CWBDB_REQUEST_INVALID_CONVERSION=CWBDB_START+6;

(*------------------------------------------------------------------*)
(* The Data Access server is not started. It must be started before *)
(* continuing.                                                      *)
(*------------------------------------------------------------------*)
 CWBDB_SERVER_NOT_ACTIVE             =CWBDB_START+7;

(*------------------------------------------------------------------*)
(* Attempt to set a parameter failed. Re-try. If error persists,    *)
(* there may be a lack of available memory.                         *)
(*------------------------------------------------------------------*)
 CWBDB_PARAMETER_ERROR               =CWBDB_START+8;

(*------------------------------------------------------------------*)
(* Could not create a clone request.                                *)
(*------------------------------------------------------------------*)
 CWBDB_CLONE_CREATION_ERROR          =CWBDB_START+9;

(*------------------------------------------------------------------*)
(* The data format object was not valid for this connection.        *)
(*------------------------------------------------------------------*)
 CWBDB_INVALID_DATA_FORMAT_FOR_CONNECTION  =CWBDB_START+10;

(*------------------------------------------------------------------*)
(* The data format object is already being used by another request. *)
(*------------------------------------------------------------------*)
 CWBDB_DATA_FORMAT_IN_USE            =CWBDB_START+11;

(*------------------------------------------------------------------*)
(* The data format object does not match the format of the data.    *)
(*------------------------------------------------------------------*)
 CWBDB_INVALID_DATA_FORMAT_FOR_DATA  =CWBDB_START+12;

(*------------------------------------------------------------------*)
(* The string provided was too long for the parameter.              *)
(*------------------------------------------------------------------*)
 CWBDB_STRING_ARG_TOO_LONG           =CWBDB_START+13;

(*------------------------------------------------------------------*)
(* Invalid internally generated arguemtn (not user supplied)        *)
(*------------------------------------------------------------------*)
 CWBDB_INVALID_INTERNAL_ARG          =CWBDB_START+14;

(*------------------------------------------------------------------*)
(* Value of numeric argument is invalid.                            *)
(*------------------------------------------------------------------*)
 CWBDB_INVALID_NUMERIC_ARG           =CWBDB_START+15;

(*------------------------------------------------------------------*)
(* Value of argument is invalid.                                    *)
(*------------------------------------------------------------------*)
 CWBDB_INVALID_ARG                   =CWBDB_START+16;

(*------------------------------------------------------------------*)
(* The statement provided was not a SELECT statement. This call     *)
(* requires a SELECT statement.                                     *)
(*------------------------------------------------------------------*)
 CWBDB_STMT_NOT_SELECT               =CWBDB_START+17;

(*------------------------------------------------------------------*)
(* The connection is in stream fetch mode. Cannot perform desired   *)
(* operation until stream fetch has ended.                          *)
(*------------------------------------------------------------------*)
 CWBDB_STREAM_FETCH_NOT_COMPLETE     =CWBDB_START+18;

(*------------------------------------------------------------------*)
(* The connection is not in stream fetch mode and must be in order  *)
(* to perform the desired operation.                                *)
(*------------------------------------------------------------------*)
 CWBDB_STREAM_FETCH_NOT_ACTIVE       =CWBDB_START+19;

(*------------------------------------------------------------------*)
(* Pointer to data processor in request object is null.             *)
(*------------------------------------------------------------------*)
 CWBDB_MISSING_DATA_PROCESSOR        =CWBDB_START+20;

(*------------------------------------------------------------------*)
(* Cannot create a clone of an attributes request.                  *)
(*------------------------------------------------------------------*)
 CWBDB_ILLEGAL_CLONE_REQUEST_TYPE    =CWBDB_START+21;

(*------------------------------------------------------------------*)
(* Data were received from the server, but none were requested.     *)
(*------------------------------------------------------------------*)
 CWBDB_UNSOLICITED_DATA              =CWBDB_START+22;

(*------------------------------------------------------------------*)
(* Data were requested from the server, but not all were received.  *)
(*------------------------------------------------------------------*)
 CWBDB_MISSING_DATA                  =CWBDB_START+23;

(*------------------------------------------------------------------*)
(* Bitstream within a parameter is invalid.                         *)
(*------------------------------------------------------------------*)
 CWBDB_PARM_INVALID_BITSTREAM        =CWBDB_START+24;

(*------------------------------------------------------------------*)
(*                                                                  *)
(*------------------------------------------------------------------*)
 CWBDB_CONSISTENCY_TOKEN_ERROR       =CWBDB_START+25;

(*------------------------------------------------------------------*)
(*                                                                  *)
(*------------------------------------------------------------------*)
 CWBDB_INVALID_FUNCTION              =CWBDB_START+26;

(*------------------------------------------------------------------*)
(*                                                                  *)
(*------------------------------------------------------------------*)
 CWBDB_FORMAT_INVALID_ARG           =CWBDB_START+27;

(*------------------------------------------------------------------*)
(*                                                                  *)
(*------------------------------------------------------------------*)
 CWBDB_INVALID_COLUMN_POSITION       =CWBDB_START+28;

(*------------------------------------------------------------------*)
(*                                                                  *)
(*------------------------------------------------------------------*)
 CWBDB_INVALID_COLUMN_TYPE           =CWBDB_START+29;

(*------------------------------------------------------------------*)
(*                                                                  *)
(*------------------------------------------------------------------*)
 CWBDB_ROW_VECTOR_NOT_EMPTY          =CWBDB_START+30;

(*------------------------------------------------------------------*)
(*                                                                  *)
(*------------------------------------------------------------------*)
 CWBDB_ROW_VECTOR_EMPTY              =CWBDB_START+31;

(*------------------------------------------------------------------*)
(*                                                                  *)
(*------------------------------------------------------------------*)
 CWBDB_MEMORY_ALLOCATION_FAILURE     =CWBDB_START+32;

(*------------------------------------------------------------------*)
(*                                                                  *)
(*------------------------------------------------------------------*)
 CWBDB_INVALID_CONVERSION            =CWBDB_START+33;

(*------------------------------------------------------------------*)
(*                                                                  *)
(*------------------------------------------------------------------*)
 CWBDB_DATASTREAM_TOO_SHORT          =CWBDB_START+34;

(*------------------------------------------------------------------*)
(*                                                                  *)
(*------------------------------------------------------------------*)
 CWBDB_SQL_WARNING                   =CWBDB_START+35;

(*------------------------------------------------------------------*)
(*                                                                  *)
(*------------------------------------------------------------------*)
 CWBDB_SQL_ERROR                     =CWBDB_START+36;

(*------------------------------------------------------------------*)
(*                                                                  *)
(*------------------------------------------------------------------*)
 CWBDB_SQL_PARAMETER_WARNING         =CWBDB_START+37;

(*------------------------------------------------------------------*)
(*                                                                  *)
(*------------------------------------------------------------------*)
 CWBDB_SQL_PARAMETER_ERROR           =CWBDB_START+38;

(*------------------------------------------------------------------*)
(*                                                                  *)
(*------------------------------------------------------------------*)
 CWBDB_LIST_SERVER_WARNING           =CWBDB_START+39;

(*------------------------------------------------------------------*)
(*                                                                  *)
(*------------------------------------------------------------------*)
 CWBDB_LIST_SERVER_ERROR             =CWBDB_START+40;

(*------------------------------------------------------------------*)
(*                                                                  *)
(*------------------------------------------------------------------*)
 CWBDB_LIST_PARAMETER_WARNING        =CWBDB_START+41;

(*------------------------------------------------------------------*)
(*                                                                  *)
(*------------------------------------------------------------------*)
 CWBDB_LIST_PARAMETER_ERROR          =CWBDB_START+42;

(*------------------------------------------------------------------*)
(*                                                                  *)
(*------------------------------------------------------------------*)
 CWBDB_NDB_FILE_SERVER_WARNING       =CWBDB_START+43;

(*------------------------------------------------------------------*)
(*                                                                  *)
(*------------------------------------------------------------------*)
 CWBDB_NDB_FILE_SERVER_ERROR         =CWBDB_START+44;

(*------------------------------------------------------------------*)
(*                                                                  *)
(*------------------------------------------------------------------*)
 CWBDB_FILE_PARAMETER_WARNING        =CWBDB_START+45;

(*------------------------------------------------------------------*)
(*                                                                  *)
(*------------------------------------------------------------------*)
 CWBDB_FILE_PARAMETER_ERROR          =CWBDB_START+46;

(*------------------------------------------------------------------*)
(*                                                                  *)
(*------------------------------------------------------------------*)
 CWBDB_GENERAL_SERVER_WARNING        =CWBDB_START+47;

(*------------------------------------------------------------------*)
(*                                                                  *)
(*------------------------------------------------------------------*)
 CWBDB_GENERAL_SERVER_ERROR          =CWBDB_START+48;

(*------------------------------------------------------------------*)
(*                                                                  *)
(*------------------------------------------------------------------*)
 CWBDB_EXIT_PROGRAM_WARNING          =CWBDB_START+49;

(*------------------------------------------------------------------*)
(*                                                                  *)
(*------------------------------------------------------------------*)
 CWBDB_EXIT_PROGRAM_ERROR            =CWBDB_START+50;

(*------------------------------------------------------------------*)
(* Target data buffer is smaller than source buffer                 *)
(*------------------------------------------------------------------*)
 CWBDB_DATA_BUFFER_TOO_SMALL        =CWBDB_START+51;

(*------------------------------------------------------------------*)
(* Received error back from PiNlConverter                           *)
(*------------------------------------------------------------------*)
 CWBDB_NL_CONVERSION_ERROR          =CWBDB_START+52;

(*------------------------------------------------------------------*)
(* Received a communications error during processing                *)
(*------------------------------------------------------------------*)
 CWBDB_COMMUNICATIONS_ERROR         =CWBDB_START+53;

(*------------------------------------------------------------------*)
(* Value of argument is invalid - API level.                        *)
(*------------------------------------------------------------------*)
 CWBDB_INVALID_ARG_API               =CWBDB_START+54;

(*------------------------------------------------------------------*)
(* Data handler not found in data handler list.                     *)
(*------------------------------------------------------------------*)
 CWBDB_MISSING_DATA_HANDLER          =CWBDB_START+55;

(*------------------------------------------------------------------*)
(* Invalid datastream in catalog request.                           *)
(*------------------------------------------------------------------*)
 CWBDB_REQUEST_DATASTREAM_NOT_VALID  =CWBDB_START+56;

(*------------------------------------------------------------------*)
(* Server incapable of performing desired function.                 *)
(*------------------------------------------------------------------*)
 CWBDB_SERVER_UNABLE                 =CWBDB_START+57;

(*------------------------------------------------------------------*)
(* Stream fetch complete. NOTE: Informational; not an error.        *)
(*  There is no message or help text for this return code.          *)
(*------------------------------------------------------------------*)
 CWBDB_LAST_STREAM_CHUNK             =CWBDB_START+99;

(*------------------------------------------------------------------*)
(* TYPEDEFS:                                                        *)
(*------------------------------------------------------------------*)
type
 cwbDB_ConnectionHandle=cwb_Handle;
 cwbDB_RequestHandle=cwb_Handle;
 cwbDB_FormatHandle=cwb_Handle;
 cwbDB_DataHandle=cwb_Handle;

(*------------------------------------------------------------------*)
(*                                                                  *)
(* Definitions for parameter types                                  *)
(*                                                                  *)
(*------------------------------------------------------------------*)
const
 CWBDB_PERIOD_NAME_CONV  =0;  (* SQL naming convention (.)     *)
 CWBDB_SLASH_NAME_CONV   =1;  (* Native AS/400 naming convention (/) *)

 CWBDB_IGNORE_ERROR      =0;  (* Ignore decimal data error     *)
 CWBDB_CORRECT_ERROR     =1;  (* Correct decimal data error    *)

 CWBDB_NONE              =0;  (* *NONE - No commitment control *)
 CWBDB_CURSOR_STABILITY  =1;  (* *CS   - Cursor stability      *)
 CWBDB_CHANGE            =2;  (* *CHG  - Change                *)
 CWBDB_ALL               =3;  (* *ALL  - All                   *)

 CWBDB_ALL_FILES_ATTRIBUTES      =1; (* All files              *)
 CWBDB_PHYSICAL_FILES_ATTRIBUTES =2; (* Only physical files    *)
 CWBDB_LOGICAL_FILES_ATTRIBUTES  =3; (* Logical files          *)
 CWBDB_ODBC_TABLES_ATTRIBUTES    =4; (* phys. files, tables, indexes *)
 CWBDB_ODBC_VIEWS_ATTRIBUTES     =5; (* logical files and views*)

 CWBDB_ALL_FILES         =1;  (* All files                     *)
 CWBDB_SOURCE_FILES      =2;  (* Source files                  *)
 CWBDB_DATA_FILES        =3;  (* Data files                    *)

 CWBDB_UNIQUE_INDEX      =1;  (* Index is unique               *)
 CWBDB_DUPLICATE_INDEX   =2;  (* Duplicates are allowed        *)
 CWBDB_DUP_NULL_INDEX    =3;  (* Duplicate null values are allowed *)

 CWBDB_ALL_STATEMENTS     =1;  (* All statement types          *)
 CWBDB_DECLARE_STATEMENTS =2;  (* Declare statements           *)
 CWBDB_SELECT_STATEMENTS  =3;  (* Select statements            *)
 CWBDB_EXEC_STATEMENTS    =4;  (* Executable statements        *)

 CWBDB_GET_LIBRARY_NAME  =$01000000; (* Retrieve library name *)
 CWBDB_GET_LIBRARY_DESC  =$02000000; (* Retrieve description  *)
 CWBDB_GET_LIBRARY_OWNER =$04000000; (* Retrieve owner        *)

 CWBDB_GET_RDB_NAME     =$01000000;  (* Remote Relational Database name *)
 CWBDB_GET_RDB_DEVICE   =$02000000;  (* Relational Database device *)
 CWBDB_GET_RDB_MODE     =$04000000;  (* Relational Database mode *)
 CWBDB_GET_RDB_RMTLOC   =$08000000;  (* Relational Database remote location *)
 CWBDB_GET_RDB_LOCLOC   =$10000000;  (* Local location        *)
 CWBDB_GET_RDB_RMTNET   =$20000000;  (* Remote network        *)
 CWBDB_GET_RDB_TPNAME   =$40000000;  (* Remote Transaction Program name *)
 CWBDB_GET_RDB_DESC     =$80000000;  (* Relational Database Text description *)
 CWBDB_GET_RDB_TPNDISP  =$00010000;  (* Transaction Program name display *)
 CWBDB_GET_RDB_PGM      =$00040000;  (* Relational Database program *)
 CWBDB_GET_RDB_PGMLIB   =$00080000;  (* Relational Database program library *)
 CWBDB_GET_RDB_PGMLEVEL =$00100000;  (* Relational Database program level *)

 CWBDB_GET_SQLPKG_LIB   =$01000000;  (* SQL package library   *)
 CWBDB_GET_SQLPKG_NAME  =$02000000;  (* SQL Package name      *)
 CWBDB_GET_SQLPKG_DESC  =$04000000;  (* Text description of package*)

 CWBDB_GET_SQLSTMT_LIB    =$01000000; (* SQL package library  *)
 CWBDB_GET_SQLSTMT_PKG    =$02000000; (* SQL statement package*)
 CWBDB_GET_SQLSTMT_NAME   =$04000000; (* SQL statement name   *)
 CWBDB_GET_SQLSTMT_TYPE   =$08000000; (* Statement Type       *)
 CWBDB_GET_SQLSTMT_TEXT   =$10000000; (* Text of statement    *)
 CWBDB_GET_SQLSTMT_PM_CNT =$20000000; (* Parameter marker count*)

 CWBDB_GET_FILE_LIB     =$01000000;  (* Library name          *)
 CWBDB_GET_FILE_REMARKS =$02000000;  (* Remarks               *)
 CWBDB_GET_FILE_NAME    =$04000000;  (* File name             *)
 CWBDB_GET_FILE_ATTRIB  =$08000000;  (* Attribute             *)
 CWBDB_GET_FILE_DESC    =$20000000;  (* Text description      *)
 CWBDB_GET_FILE_COL_CNT =$40000000;  (* Number of columns     *)
 CWBDB_GET_FILE_AUTH    =$80000000;  (* Current authority     *)

 CWBDB_GET_MBR_LIB      =$01000000;  (* Library of member     *)
 CWBDB_GET_MBR_FILE     =$02000000;  (* Member file           *)
 CWBDB_GET_MBR_NAME     =$04000000;  (* Member name           *)
 CWBDB_GET_MBR_DESC     =$08000000;  (* Text description      *)

 CWBDB_GET_FMT_LIB      =$01000000;  (* Record format library *)
 CWBDB_GET_FMT_FILE     =$02000000;  (* Record format file    *)
 CWBDB_GET_FMT_NAME     =$04000000;  (* Record format name    *)
 CWBDB_GET_FMT_REC_LEN  =$08000000;  (* Record length         *)
 CWBDB_GET_FMT_DESC     =$10000000;  (* Text description      *)

 CWBDB_GET_FLD_LIB       =$01000000; (* Field library         *)
 CWBDB_GET_FLD_REMARKS   =$02000000; (* Field remarks         *)
 CWBDB_GET_FLD_FILE      =$04000000; (* Field file            *)
 CWBDB_GET_FLD_NAME      =$10000000; (* Field name            *)
 CWBDB_GET_FLD_DESC      =$20000000; (* Text description      *)
 CWBDB_GET_FLD_DATA_TYPE =$40000000; (* Data type             *)
 CWBDB_GET_FLD_LEN       =$80000000; (* Length                *)
 CWBDB_GET_FLD_NULL      =$00010000; (* Null capability       *)
 CWBDB_GET_FLD_RADIX     =$00020000; (* Radix                 *)
 CWBDB_GET_FLD_PREC      =$00040000; (* Precision             *)
 CWBDB_GET_FLD_SCALE     =$00080000; (* Scale                 *)

 CWBDB_GET_IDX_TBL_LIB   =$01000000; (* Library name          *)
 CWBDB_GET_IDX_TBL_NAME  =$04000000; (* Table name            *)
 CWBDB_GET_IDX_UNIQUE    =$08000000; (* Index unique rule     *)
 CWBDB_GET_IDX_IDX_LIB   =$10000000; (* Index library         *)
 CWBDB_GET_IDX_IDX_NAME  =$20000000; (* Index name            *)
 CWBDB_GET_IDX_COL_CNT   =$40000000; (* Column count          *)
 CWBDB_GET_IDX_COL_NAME  =$80000000; (* Column names          *)
 CWBDB_GET_IDX_COL_SEQ   =$00010000; (* Column sequence       *)
 CWBDB_GET_IDX_COLLAT    =$00020000; (* Collation sequence    *)

 CWBDB_GET_SP_COL_LIB       =$01000000; (* Library name       *)
 CWBDB_GET_SP_COL_TABLE     =$04000000; (* Table name         *)
 CWBDB_GET_SP_COL_COL_NAME  =$08000000; (* Column name        *)
 CWBDB_GET_SP_COL_DATA_TYPE =$10000000; (* Data type          *)
 CWBDB_GET_SP_COL_PRECISION =$20000000; (* Precision          *)
 CWBDB_GET_SP_COL_LENGTH    =$40000000; (* Length             *)
 CWBDB_GET_SP_COL_SCALE     =$80000000; (* Scale              *)

(* Primary Key Information constants                                *)
 CWBDB_GET_PR_KEY_LIB       =$01000000; (* Library name       *)
 CWBDB_GET_PR_KEY_FILE      =$08000000; (* File name          *)
 CWBDB_GET_PR_KEY_COL_ID    =$10000000; (* Column ID          *)
 CWBDB_GET_PR_KEY_COL_SEQ   =$20000000; (* Column Sequence    *)

(* Foreign Key Primary Key Information constants                    *)
 CWBDB_GET_FG_PRKEY_LIB     =$01000000; (* Library name       *)
 CWBDB_GET_FG_PRKEY_FILE    =$04000000; (* File name          *)
 CWBDB_GET_FG_PRKEY_COL_ID  =$08000000; (* Column ID          *)
(* Foreign Key Information constants                                *)
 CWBDB_GET_FG_KEY_LIB       =$10000000; (* Library name       *)
 CWBDB_GET_FG_KEY_FILE      =$40000000; (* File name          *)
 CWBDB_GET_FG_KEY_COL_ID    =$80000000; (* Column ID          *)
 CWBDB_GET_FG_KEY_SEQ       =$00010000; (* Key sequence       *)
 CWBDB_GET_FG_KEY_UPDATE    =$00020000; (* Update rule        *)
 CWBDB_GET_FG_KEY_DELETE    =$00040000; (* Delete rule        *)

 CWBDB_NOT_NULLABLE      =$F0;   (* not null capable          *)
 CWBDB_NULLABLE          =$F1;   (* Null capable              *)

 CWBDB_SET_LIBRARY_CREATE_AUTHORITY =0; (* *LIBCRTAUT          *)
 CWBDB_SET_ALL_AUTHORITY            =1; (* *ALL                *)
 CWBDB_SET_CHANGE_AUTHORITY         =2; (* *CHANGE             *)
 CWBDB_SET_EXCLUDE_AUTHORITY        =3; (* *EXCLUDE            *)
 CWBDB_SET_USE_AUTHORITY            =4; (* *USE                *)
 CWBDB_SET_SAME_AUTHORITY           =5; (* *SAME               *)

 CWBDB_DO_NOT_COPY_DATA  =0;   (* Do not copy data to new file *)
 CWBDB_COPY_DATA         =1;   (* Copy data to new file        *)

 CWBDB_NORMAL_PREPARE    =0;   (* Normal prepare (default)     *)
 CWBDB_ENHANCED_PREPARE  =1;   (* Enhanced prepare             *)

 CWBDB_DESC_ALIAS_NAMES =$D5; (* Use alias names (default)    *)
 CWBDB_DESC_NAMES_ONLY  =$E2; (* Use names only               *)
 CWBDB_DESC_LABELS      =$D3; (* Use labels                   *)

 CWBDB_CURSOR_NOT_SCROLLABLE =0; (* Non-scrollable (default)   *)
 CWBDB_CURSOR_SCROLLABLE     =1; (* Scrollable                 *)

 CWBDB_SCROLL_NEXT         =0;   (* Fetch next record          *)
 CWBDB_SCROLL_PREVIOUS     =1;   (* Fetch previous record      *)
 CWBDB_SCROLL_FIRST        =2;   (* Fetch first record         *)
 CWBDB_SCROLL_LAST         =3;   (* Fetch last record          *)
 CWBDB_SCROLL_BEFORE_FIRST =4;   (* Fetch before first record (BOF)*)
 CWBDB_SCROLL_AFTER_LAST   =5;   (* Fetch after last record   (EOF)*)
 CWBDB_SCROLL_CURRENT      =6;   (* Fetch current record       *)
 CWBDB_SCROLL_RELATIVE     =7;   (* Fetch relative from cursor *)

 CWBDB_WORK   =0;                (* Commit/Rollback work option*)
 CWBDB_HOLD   =1;                (* Commit/Rollback hold option*)

 CWBDB_READ     =$80;           (* Indicates read intent      *)
 CWBDB_WRITE    =$40;           (* Indicates write intent     *)
 CWBDB_UPDATE   =$20;           (* Indicates update intent    *)
 CWBDB_DELETE   =$10;           (* Indicates delete intent    *)
 CWBDB_OPEN_ALL =$F0;           (* Indicates all of the above *)

 CWBDB_SYSTEM    =0;             (* Returns system format      *)
 CWBDB_LOCAL     =1;             (* Returns local format       *)

 CWBDB_PCNOCONVERSION =0;        (* No conversion done         *)
 CWBDB_PCSTRING       =1;        (* character data             *)
 CWBDB_PCLONG         =2;        (*  4 byte integer            *)
 CWBDB_PCSHORT        =3;        (*  2 byte integer            *)
 CWBDB_PCFLOAT        =4;        (*  4 byte floating point     *)
 CWBDB_PCDOUBLE       =5;        (*  8 byte floating point     *)
 CWBDB_PCPACKED       =6;        (*    packed decimal          *)
 CWBDB_PCZONED        =7;        (*    zoned decimal           *)
 CWBDB_PCINVALIDTYPE  =8;        (*                            *)
 CWBDB_PCVARSTRING    =9;        (* Varying length string      *)
 CWBDB_PCGRAPHIC      =10;       (* Graphic data "pure DBCS"   *)
 CWBDB_PCVARGRAPHIC   =11;       (* Varying length graphic     *)


 CWBDB_DATE_FMT_JUL          =0;      (* Julian                     *)
 CWBDB_DATE_FMT_MDY          =1;      (* month day year             *)
 CWBDB_DATE_FMT_DMY          =2;      (* day month year             *)
 CWBDB_DATE_FMT_YMD          =3;      (* year month day             *)
 CWBDB_DATE_FMT_USA          =4;      (* USA                        *)
 CWBDB_DATE_FMT_ISO          =5;      (* ISO                        *)
 CWBDB_DATE_FMT_EUR          =6;      (* IBM Europe                 *)
 CWBDB_DATE_FMT_JIS          =7;      (* IBM Japan                  *)

 CWBDB_DATE_SEP_SLASH        =0;      (* slash    03/17/94          *)
 CWBDB_DATE_SEP_DASH         =1;      (* dash     03-17-94          *)
 CWBDB_DATE_SEP_PERIOD       =2;      (* period   03.17.94          *)
 CWBDB_DATE_SEP_COMMA        =3;      (* comma    03,17,94          *)
 CWBDB_DATE_SEP_BLANK        =4;      (* blank    03 17 94          *)

 CWBDB_TIME_FMT_HMS          =0;      (* hours minutes seconds      *)
 CWBDB_TIME_FMT_USA          =1;      (* USA                        *)
 CWBDB_TIME_FMT_ISO          =2;      (* ISO                        *)
 CWBDB_TIME_FMT_EUR          =3;      (* Europe                     *)
 CWBDB_TIME_FMT_JIS          =4;      (* Japan                      *)

 CWBDB_TIME_SEP_COLON        =0;      (* colon    11:10:03          *)
 CWBDB_TIME_SEP_PERIOD       =1;      (* period   11.10.03          *)
 CWBDB_TIME_SEP_COMMA        =2;      (* comma    11,10,03          *)
 CWBDB_TIME_SEP_BLANK        =3;      (* blank    11 10 03          *)

 CWBDB_DECIMAL_SEP_PERIOD    =0;      (* period     123.45          *)
 CWBDB_DECIMAL_SEP_COMMA     =1;      (* comma      123,45          *)

 CWBDB_NLSS_SORT_HEX         =0;      (* *HEX                       *)
 CWBDB_NLSS_SORT_SHARED      =1;      (* *SHARED                    *)
 CWBDB_NLSS_SORT_UNIQUE      =2;      (* *UNIQUE                    *)
 CWBDB_NLSS_SORT_USER        =3;      (* *USER                      *)

 CWBDB_PZ_PC_SIGN            =0;      (* Packed/zoned use PC sign   *)
 CWBDB_PZ_400_SIGN           =1;      (* Packed/zoned use 400 sign  *)

 CWBDB_PZ_LEAVE_UNXLATE      =0;      (* Ignore untranslateble p/z  *)
 CWBDB_PZ_UNXLATE_ERROR      =1;      (* Untranslateble p/z is error*)

(*------------------------------------------------------------------*)
(*                                                                  *)
(* Structure Name:  cwbDB_SQLCA                                     *)
(*                                                                  *)
(* Used With APIs:  cwbDB_ReturnSQLCA                               *)
(*                                                                  *)
(* Usage Notes:                                                     *)
(*                                                                  *)
(*------------------------------------------------------------------*)
type
 cwbDB_SQLCA=packed record
  sqlcaid :array[0..7] of char;   (* Eyecatcher = 'SQLCA   '        *)
  sqlcabc :integer;               (* SQLCA size in bytes = 136      *)
  sqlcode :integer;               (* SQL return code                *)
  sqlerrml:word;                  (* Length for SQLERRMC            *)
  sqlerrmc:array[0..69]of char;   (* Error message tokens           *)
  sqlerrp :array[0..7]of char;    (* Diagnostic information         *)
  sqlerrd :array[0..5]of integer; (* Diagnostic information         *)
  sqlwarn :array[0..10]of char;   (* Warning flags                  *)
  sqlext  :array[0..4]of char;    (* Reserved                       *)
 end;

(********************************************************************)
(*   Add a member to a file on the AS/400.                          *)
(********************************************************************)
function cwbDB_AddMember(
                             request:cwbDB_RequestHandle;
                             errorHandle:cwbSV_ErrHandle):integer; stdcall;

(********************************************************************)
(*   Activates the changes that were made to server attributes      *)
(*   by previous calls - (naming convention, commitment control,    *)
(*   etc.)  Use this to change server attributes after the server   *)
(*   has been started.                                              *)
(********************************************************************)
function cwbDB_ApplyAttributes(
                             connection:cwbDB_ConnectionHandle;
                             errorHandle:cwbSV_ErrHandle):integer; stdcall;

(********************************************************************)
(*   Clear data from a member in an AS/400 file.                    *)
(********************************************************************)
function cwbDB_ClearMember(
                             request:cwbDB_RequestHandle;
                             errorHandle:cwbSV_ErrHandle):integer; stdcall;

(********************************************************************)
(*   Clear all statements from a SQL package.                       *)
(********************************************************************)
function cwbDB_ClearPackage(
                             request:cwbDB_RequestHandle;
                             errorHandle:cwbSV_ErrHandle):integer; stdcall;

(********************************************************************)
(*   Close an open cursor.                                          *)
(********************************************************************)
function cwbDB_Close(
                             request:cwbDB_RequestHandle;
                             errorHandle:cwbSV_ErrHandle):integer; stdcall;

(********************************************************************)
(*   Perform a commit operation to commit a unit of work.           *)
(********************************************************************)
function cwbDB_Commit(
                             request:cwbDB_RequestHandle;
                             errorHandle:cwbSV_ErrHandle):integer; stdcall;

(********************************************************************)
(*   Perform a Distributed Relational Database Architecture (DRDA)  *)
(*   connection management function.  This API is used to establish *)
(*   and switch between connections to other Relational Databases.  *)
(********************************************************************)
function cwbDB_Connect(
                             request:cwbDB_RequestHandle;
                             errorHandle:cwbSV_ErrHandle):integer; stdcall;

(********************************************************************)
(*   Allocate a handle to a database request.  This handle will     *)
(*   be used on subsequent API calls that request object            *)
(*   information.                                                   *)
(********************************************************************)
function cwbDB_CreateCatalogRequestHandle(
                             connection:cwbDB_ConnectionHandle;
                             var request:cwbDB_RequestHandle;
                             errorHandle:cwbSV_ErrHandle):integer; stdcall;

(********************************************************************)
(*   Allocate a handle to an AS/400 database access server.         *)
(********************************************************************)
// !!! UNICODE _A & _W !!
function cwbDB_CreateConnectionHandle(
                             const systemName:pchar;
                             var connection:cwbDB_ConnectionHandle;
                             errorHandle:cwbSV_ErrHandle):integer; stdcall;

(********************************************************************)
(*   Allocate a handle to a description of SQL data.                *)
(********************************************************************)
function cwbDB_CreateDataFormatHandle(
                             connection:cwbDB_ConnectionHandle;
                             var format:cwbDB_FormatHandle;
                             errorHandle:cwbSV_ErrHandle):integer; stdcall;

(********************************************************************)
(*   Allocate a handle to a data object.                            *)
(********************************************************************)
function cwbDB_CreateDataHandle(
                             var dataHandle:cwbDB_DataHandle;
                             errorHandle:cwbSV_ErrHandle):integer; stdcall;

(********************************************************************)
(*   Create a file based on existing file.                          *)
(********************************************************************)
function cwbDB_CreateDuplicateFile(
                             request:cwbDB_RequestHandle;
                             copyDataIndicator:cwb_Boolean;
                             errorHandle:cwbSV_ErrHandle):integer; stdcall;
(********************************************************************)
(*   Allocate a handle to a database request.  This handle will     *)
(*   be used on subsequent API calls that request operations to     *)
(*   be performed with AS/400 file objects.                         *)
(********************************************************************)
function cwbDB_CreateNDBRequestHandle(
                             connection:cwbDB_ConnectionHandle;
                             var request:cwbDB_RequestHandle;
                             errorHandle:cwbSV_ErrHandle):integer; stdcall;

(********************************************************************)
(*   Create a SQL package for preparing statements.                 *)
(********************************************************************)
function cwbDB_CreatePackage(
                             request:cwbDB_RequestHandle;
                             errorHandle:cwbSV_ErrHandle):integer; stdcall;

(********************************************************************)
(*   Allocate a handle to a description of SQL parameter marker     *)
(*   data.                                                          *)
(********************************************************************)
function cwbDB_CreateParameterMarkerFormatHandle(
                             connection:cwbDB_ConnectionHandle;
                             var format:cwbDB_FormatHandle;
                             errorHandle:cwbSV_ErrHandle):integer; stdcall;

(********************************************************************)
(*   Create a source file on the AS/400.                            *)
(********************************************************************)
function cwbDB_CreateSourcePhysicalFile(
                             request:cwbDB_RequestHandle;
                             errorHandle:cwbSV_ErrHandle):integer; stdcall;

(********************************************************************)
(*   Allocate a handle to a database request.  This handle will     *)
(*   be used on subsequent API calls that request SQL services.     *)
(********************************************************************)
function cwbDB_CreateSQLRequestHandle(
                             connection:cwbDB_ConnectionHandle;
                             var request:cwbDB_RequestHandle;
                             errorHandle:cwbSV_ErrHandle):integer; stdcall;

(********************************************************************)
(*   Deallocates a request handle.                                  *)
(********************************************************************)
function cwbDB_DeleteCatalogRequestHandle(
                             request:cwbDB_RequestHandle;
                             errorHandle:cwbSV_ErrHandle):integer; stdcall;
(********************************************************************)
(*   Deallocates the handle to the AS/400 server.                   *)
(********************************************************************)
function cwbDB_DeleteConnectionHandle(
                             connection:cwbDB_ConnectionHandle;
                             errorHandle:cwbSV_ErrHandle):integer; stdcall;
(********************************************************************)
(*   Deallocates a format handle.                                   *)
(********************************************************************)
function cwbDB_DeleteDataFormatHandle(
                             format:cwbDB_FormatHandle;
                             errorHandle:cwbSV_ErrHandle):integer; stdcall;

(********************************************************************)
(*   Deallocates a data handle.                                     *)
(********************************************************************)
function cwbDB_DeleteDataHandle(
                             dataHandle:cwbDB_DataHandle;
                             errorHandle:cwbSV_ErrHandle):integer; stdcall;

(********************************************************************)
(*   Delete a file from an AS/400.                                  *)
(********************************************************************)
function cwbDB_DeleteFile(
                             request:cwbDB_RequestHandle;
                             errorHandle:cwbSV_ErrHandle):integer; stdcall;

(********************************************************************)
(*   Deallocates a request handle.                                  *)
(********************************************************************)
function cwbDB_DeleteNDBRequestHandle(
                             request:cwbDB_RequestHandle;
                             errorHandle:cwbSV_ErrHandle):integer; stdcall;

(********************************************************************)
(*   Delete a SQL package.                                          *)
(********************************************************************)
function cwbDB_DeletePackage(
                             request:cwbDB_RequestHandle;
                             errorHandle:cwbSV_ErrHandle):integer; stdcall;

(********************************************************************)
(*   Deallocates a format handle.                                   *)
(********************************************************************)
function cwbDB_DeleteParameterMarkerFormatHandle(
                             format:cwbDB_FormatHandle;
                             errorHandle:cwbSV_ErrHandle):integer; stdcall;
(********************************************************************)
(*   Deallocates a request handle.                                  *)
(********************************************************************)
function cwbDB_DeleteSQLRequestHandle(
                             request:cwbDB_RequestHandle;
                             errorHandle:cwbSV_ErrHandle):integer; stdcall;

(********************************************************************)
(*   Describes a prepared statement.  If there is no result set,    *)
(*   no column descriptions will be returned.                       *)
(********************************************************************)
function cwbDB_Describe(
                             request:cwbDB_RequestHandle;
                             errorHandle:cwbSV_ErrHandle):integer; stdcall;

(********************************************************************)
(*   Describes the parameter markers for a prepared statement.      *)
(*   If the statement is an "UPDATE WHERE CURRENT OF CURSOR", the   *)
(*   cursor must be open before the describe parameter markers can  *)
(*   be performed.                                                  *)
(********************************************************************)
function cwbDB_DescribeParameterMarkers(
                             request:cwbDB_RequestHandle;
                             errorHandle:cwbSV_ErrHandle):integer; stdcall;

(********************************************************************)
(*   This API will prepare a select statement, open a cursor and    *)
(*   fetch all resulting data. The row data will be returned to the *)
(*   application in blocks, the size of which will be optimized for *)
(*   the communication mechanism.  To get additional blocks, use    *)
(*   the cwbDB_MoreStreamData API.                                  *)
(********************************************************************)
// warning UNICODE !!
function cwbDB_DynamicStreamFetch(
                             request:cwbDB_RequestHandle;
                             const statementText:pchar;
                             data:cwbDB_DataHandle;
                             indicators:cwbDB_DataHandle;
                             formatHandle:cwbDB_FormatHandle;
                             errorHandle:cwbSV_ErrHandle):integer; stdcall;
(********************************************************************)
(*   Cancel the stream fetch operation before all the data has      *)
(*   been returned.                                                 *)
(********************************************************************)
function cwbDB_EndStreamFetch(
                             request:cwbDB_RequestHandle;
                             errorHandle:cwbSV_ErrHandle):integer; stdcall;
(********************************************************************)
(*   Execute a prepared SQL statement.                              *)
(********************************************************************)
function cwbDB_Execute(
                             request:cwbDB_RequestHandle;
                             errorHandle:cwbSV_ErrHandle):integer; stdcall;

(********************************************************************)
(*   Prepare and execute a SQL statement.                           *)
(********************************************************************)
function cwbDB_ExecuteImmediate(
                             request:cwbDB_RequestHandle;
                             errorHandle:cwbSV_ErrHandle):integer; stdcall;

(********************************************************************)
(*   This API will perform a stream fetch (see previous API) for    *)
(*   a statement that is already prepared in a SQL package.         *)
(********************************************************************)
// warning UNICODE !
function cwbDB_ExtendedDynamicStreamFetch(
                             request:cwbDB_RequestHandle;
                             const libraryName:pchar;
                             const packageName:pchar;
                             const statementName:pchar;
                             data:cwbDB_DataHandle;
                             indicators:cwbDB_DataHandle;
                             formatHandle:cwbDB_FormatHandle;
                             errorHandle:cwbSV_ErrHandle):integer; stdcall;

(********************************************************************)
(*   Fetch a row or block of rows (this is controlled by the        *)
(*   cwbDB_SetBlockCount API) from an open cursor.                  *)
(********************************************************************)
function cwbDB_Fetch(
                             request:cwbDB_RequestHandle;
                             errorHandle:cwbSV_ErrHandle):integer; stdcall;

(********************************************************************)
(*   Returns the Coded Character Set Identifier (CCSID) for a       *)
(*   specified column of data.                                      *)
(********************************************************************)
function cwbDB_GetColumnCCSID(
                             format:cwbDB_FormatHandle;
                             location:dword;
                             columnPosition:dword;
                             var dataCCSID:word;
                             errorHandle:cwbSV_ErrHandle):integer; stdcall;

(********************************************************************)
(*   Returns the number of columns of data that are described by    *)
(*   the data format.                                               *)
(********************************************************************)
function cwbDB_GetColumnCount(
                             format:cwbDB_FormatHandle;
                             var columnCount:dword;
                             errorHandle:cwbSV_ErrHandle):integer; stdcall;

(********************************************************************)
(*   Returns the length (in bytes) of the data for a specified      *)
(*   column.                                                        *)
(********************************************************************)
function cwbDB_GetColumnLength(
                             format:cwbDB_FormatHandle;
                             location:dword;
                             columnPosition:dword;
                             var dataLength:dword;
                             errorHandle:cwbSV_ErrHandle):integer; stdcall;

(********************************************************************)
(*   Returns the column name (if it exists) for a column of data.   *)
(********************************************************************)
function cwbDB_GetColumnName(
                             format:cwbDB_FormatHandle;
                             columnPosition:dword;
                             columnHandle:cwbDB_DataHandle;
                             errorHandle:cwbSV_ErrHandle):integer; stdcall;

(********************************************************************)
(*   Returns the precision for a specified column of data.          *)
(********************************************************************)
function cwbDB_GetColumnPrecision(
                             format:cwbDB_FormatHandle;
                             location:dword;
                             columnPosition:dword;
                             var dataPrecision:word;
                             errorHandle:cwbSV_ErrHandle):integer; stdcall;

(********************************************************************)
(*   Returns the scale for a specified column of data.              *)
(********************************************************************)
function cwbDB_GetColumnScale(
                             format:cwbDB_FormatHandle;
                             location:dword;
                             columnPosition:dword;
                             var dataScale:word;
                             errorHandle:cwbSV_ErrHandle):integer; stdcall;

(********************************************************************)
(*   Returns the data type for a specified column of data.          *)
(********************************************************************)
function cwbDB_GetColumnType(
                             format:cwbDB_FormatHandle;
                             location:dword;
                             columnPosition:dword;
                             var dataType:shortint;
                             errorHandle:cwbSV_ErrHandle):integer; stdcall;

(********************************************************************)
(*   Get the current commitment control level.                      *)
(********************************************************************)
function cwbDB_GetCommitmentControl(
                             connection:cwbDB_ConnectionHandle;
                             var commitmentLevel:word;
                             errorHandle:cwbSV_ErrHandle):integer; stdcall;

(********************************************************************)
(*   Gets the indicator that says whether data is to be converted   *)
(*   between the client and host format.                            *)
(********************************************************************)
function cwbDB_GetConversionIndicator(
                             format:cwbDB_FormatHandle;
                             var conversionIndicator:cwb_Boolean;
                             errorHandle:cwbSV_ErrHandle):integer; stdcall;

(********************************************************************)
(*   Get the requested data from the host.  This data can include   *)
(*   the selected data, data format, host return code, and SQLCA.   *)
(********************************************************************)
function cwbDB_GetData(
                             request:cwbDB_RequestHandle;
                             errorHandle:cwbSV_ErrHandle):integer; stdcall;

(********************************************************************)
(*   Returns the length of the data contained in a data object.     *)
(********************************************************************)
function cwbDB_GetDataLength(
                             dataHandle:cwbDB_DataHandle;
                             var dataLength:dword;
                             errorHandle:cwbSV_ErrHandle):integer; stdcall;

(********************************************************************)
(*   Returns the address of the data in a data object.              *)
(********************************************************************)
function cwbDB_GetDataPointer(
                             dataHandle:cwbDB_DataHandle;
                             var data:pointer;
                             errorHandle:cwbSV_ErrHandle):integer; stdcall;

(********************************************************************)
(*   Get the current date format. See cwbDB_SetDateFormat for       *)
(*   additional information about date formats.                     *)
(********************************************************************)
function cwbDB_GetDateFormat(
                             connection:cwbDB_ConnectionHandle;
                             var dateFormat:word;
                             errorHandle:cwbSV_ErrHandle):integer; stdcall;

(********************************************************************)
(*   Get the current date separator. See cwbDB_SetDateSeparator for *)
(*   additional information about date separators.                  *)
(********************************************************************)
function cwbDB_GetDateSeparator(
                             connection:cwbDB_ConnectionHandle;
                             var dateSeparator:word;
                             errorHandle:cwbSV_ErrHandle):integer; stdcall;

(********************************************************************)
(*   Get the current decimal separator. See                         *)
(*   cwbDB_SetDecimalSeparator for additional information about     *)
(*   decimal separators.                                            *)
(********************************************************************)
function cwbDB_GetDecimalSeparator(
                             connection:cwbDB_ConnectionHandle;
                             var decimalSeparator:word;
                             errorHandle:cwbSV_ErrHandle):integer; stdcall;

(********************************************************************)
(*   Get the current setting for the decimal data error indicator.  *)
(********************************************************************)
function cwbDB_GetIgnoreDecimalDataError(
                             connection:cwbDB_ConnectionHandle;
                             var ignoreDecimalError:word;
                             errorHandle:cwbSV_ErrHandle):integer; stdcall;

(********************************************************************)
(*   Get the naming convention (SQL or native AS/400) that is in    *)
(*   effect for the specified connection.                           *)
(********************************************************************)
function cwbDB_GetNamingConvention(
                             connection:cwbDB_ConnectionHandle;
                             var namingConvention:word;
                             errorHandle:cwbSV_ErrHandle):integer; stdcall;

(********************************************************************)
(*   Returns the Coded Character Set Identifier (CCSID) for a       *)
(*   specified parameter.                                           *)
(********************************************************************)
function cwbDB_GetParameterCCSID(
                             format:cwbDB_FormatHandle;
                             location:dword;
                             parameterPosition:dword;
                             var dataCCSID:word;
                             errorHandle:cwbSV_ErrHandle):integer; stdcall;

(********************************************************************)
(*   Returns the number of parameters that are described by the     *)
(*   data format.                                                   *)
(********************************************************************)
function cwbDB_GetParameterCount(
                             format:cwbDB_FormatHandle;
                             var parameterCount:dword;
                             errorHandle:cwbSV_ErrHandle):integer; stdcall;

(********************************************************************)
(*   Returns the length (in bytes) of the data for a specified      *)
(*   parameter.                                                     *)
(********************************************************************)
function cwbDB_GetParameterLength(
                             format:cwbDB_FormatHandle;
                             location:dword;
                             parameterPosition:dword;
                             var dataLength:dword;
                             errorHandle:cwbSV_ErrHandle):integer; stdcall;

(********************************************************************)
(*   Returns the precision for a specified parameter.               *)
(********************************************************************)
function cwbDB_GetParameterPrecision(
                             format:cwbDB_FormatHandle;
                             location:dword;
                             parameterPosition:dword;
                             var dataPrecision:word;
                             errorHandle:cwbSV_ErrHandle):integer; stdcall;

(********************************************************************)
(*   Returns the scale for a specified parameter.                   *)
(********************************************************************)
function cwbDB_GetParameterScale(
                             format:cwbDB_FormatHandle;
                             location:dword;
                             parameterPosition:dword;
                             var dataScale:word;
                             errorHandle:cwbSV_ErrHandle):integer; stdcall;

(********************************************************************)
(*   Returns the data type for a specified parameter.               *)
(********************************************************************)
function cwbDB_GetParameterType(
                             format:cwbDB_FormatHandle;
                             location:dword;
                             parameterPosition:dword;
                             var dataType:shortint;
                             errorHandle:cwbSV_ErrHandle):integer; stdcall;

(********************************************************************)
(*   Returns the size (in bytes) of the data described by the       *)
(*   data format.                                                   *)
(********************************************************************)
function cwbDB_GetRowSize(
                             format:cwbDB_FormatHandle;
                             location:dword;
                             var rowSize:dword;
                             errorHandle:cwbSV_ErrHandle):integer; stdcall;

(********************************************************************)
(*   Returns the size (in bytes) of the input data described by     *)
(*   parameter marker format.                                       *)
(********************************************************************)
function cwbDB_GetSizeOfInputParameters(
                             format:cwbDB_FormatHandle;
                             location:dword;
                             var inputSize:dword;
                             errorHandle:cwbSV_ErrHandle):integer; stdcall;
(********************************************************************)
(*   Returns the size (in bytes) of the output data described by    *)
(*   parameter marker format.                                       *)
(********************************************************************)
function cwbDB_GetSizeOfOutputParameters(
                             format:cwbDB_FormatHandle;
                             location:dword;
                             var inputSize:dword;
                             errorHandle:cwbSV_ErrHandle):integer; stdcall;

(********************************************************************)
(*   Get the current time format. See cwbDB_SetTimeFormat for       *)
(*   additional information about time formats.                     *)
(********************************************************************)
function cwbDB_GetTimeFormat(
                             connection:cwbDB_ConnectionHandle;
                             var timeFormat:word;
                             errorHandle:cwbSV_ErrHandle):integer; stdcall;

(********************************************************************)
(*   Get the current time separator. See cwbDB_SetTimeSeparator for *)
(*   additional information about time separators.                  *)
(********************************************************************)
function cwbDB_GetTimeSeparator(
                             connection:cwbDB_ConnectionHandle;
                             var timeSeparator:word;
                             errorHandle:cwbSV_ErrHandle):integer; stdcall;

(********************************************************************)
(*   Returns a boolean value indicating whether the parameter is    *)
(*   input only.                                                    *)
(********************************************************************)
function cwbDB_IsParameterInput(
                             format:cwbDB_FormatHandle;
                             parameterPosition:dword;
                             var parameterIsInput:cwb_Boolean;
                             errorHandle:cwbSV_ErrHandle):integer; stdcall;

(********************************************************************)
(*   Returns a boolean value indicating whether the parameter is    *)
(*   input and output.                                              *)
(********************************************************************)
function cwbDB_IsParameterInputOutput(
                             format:cwbDB_FormatHandle;
                             parameterPosition:dword;
                             var parameterIsInputOutput:cwb_Boolean;
                             errorHandle:cwbSV_ErrHandle):integer; stdcall;

(********************************************************************)
(*   This API will get the next block of stream fetch data.         *)
(********************************************************************)
function cwbDB_MoreStreamData(
                             request:cwbDB_RequestHandle;
                             data:cwbDB_DataHandle;
                             indicators:cwbDB_DataHandle;
                             formatHandle:cwbDB_FormatHandle;
                             errorHandle:cwbSV_ErrHandle):integer; stdcall;

(********************************************************************)
(*   Open a cursor.                                                 *)
(********************************************************************)
function cwbDB_Open(
                             request:cwbDB_RequestHandle;
                             openOptions:char;
                             errorHandle:cwbSV_ErrHandle):integer; stdcall;

(********************************************************************)
(*   This API combines the open, describe and fetch operations.     *)
(*   This combined function is valuable when the statement is       *)
(*   already prepared (extended dynamic SQL).                       *)
(********************************************************************)
function cwbDB_OpenDescribeFetch(
                             request:cwbDB_RequestHandle;
                             openOptions:char;
                             errorHandle:cwbSV_ErrHandle):integer; stdcall;

(********************************************************************)
(*   Override database file reference to another file/member.       *)
(********************************************************************)
function cwbDB_OverrideFile(
                             request:cwbDB_RequestHandle;
                             errorHandle:cwbSV_ErrHandle):integer; stdcall;

(********************************************************************)
(*   Prepares an SQL statement.  If a SQL package has been set,     *)
(*   this API will prepare a statement into the package.            *)
(********************************************************************)
function cwbDB_Prepare(
                             request:cwbDB_RequestHandle;
                             errorHandle:cwbSV_ErrHandle):integer; stdcall;

(********************************************************************)
(*   This API combines the prepare and describe operations.  The    *)
(*   advantage of using this API is that the SQL component is       *)
(*   called only once.                                              *)
(********************************************************************)
function cwbDB_PrepareDescribe(
                             request:cwbDB_RequestHandle;
                             errorHandle:cwbSV_ErrHandle):integer; stdcall;

(********************************************************************)
(*   This API combines the prepare, describe, open, and fetch       *)
(*   operations. By combining these operations, performance will    *)
(*   improve because only one call is made to the SQL component     *)
(*   on the host.                                                   *)
(********************************************************************)
function cwbDB_PrepareDescribeOpenFetch(
                             request:cwbDB_RequestHandle;
                             openOptions:char;
                             errorHandle:cwbSV_ErrHandle):integer; stdcall;

(********************************************************************)
(*   Remove a member from an AS/400 file.                           *)
(********************************************************************)
function cwbDB_RemoveMember(
                             request:cwbDB_RequestHandle;
                             errorHandle:cwbSV_ErrHandle):integer; stdcall;

(********************************************************************)
(*   Remove an override from a file reference.                      *)
(********************************************************************)
function cwbDB_RemoveOverride(
                             request:cwbDB_RequestHandle;
                             errorHandle:cwbSV_ErrHandle):integer; stdcall;

(********************************************************************)
(*   Get information about the fields in an AS/400 file.            *)
(********************************************************************)
function cwbDB_RetrieveFieldInformation(
                             request:cwbDB_RequestHandle;
                             retrieveInformation:dword;
                             errorHandle:cwbSV_ErrHandle):integer; stdcall;

(********************************************************************)
(*   Get information about files on the AS/400.                     *)
(********************************************************************)
function cwbDB_RetrieveFileInformation(
                             request:cwbDB_RequestHandle;
                             retrieveInformation:dword;
                             errorHandle:cwbSV_ErrHandle):integer; stdcall;

(********************************************************************)
(*   Get information about foreign keys for an AS/400 file.         *)
(********************************************************************)
function cwbDB_RetrieveForeignKeyInformation(
                             request:cwbDB_RequestHandle;
                             retrieveInformation:dword;
                             errorHandle:cwbSV_ErrHandle):integer; stdcall;

(********************************************************************)
(*   Get information about the indices for an AS/400 file.          *)
(********************************************************************)
function cwbDB_RetrieveIndexInformation(
                             request:cwbDB_RequestHandle;
                             retrieveInformation:dword;
                             errorHandle:cwbSV_ErrHandle):integer; stdcall;

(********************************************************************)
(*   Get information about a library or list of libraries.          *)
(********************************************************************)
function cwbDB_RetrieveLibraryInformation(
                             request:cwbDB_RequestHandle;
                             retrieveInformation:dword;
                             errorHandle:cwbSV_ErrHandle):integer; stdcall;

(********************************************************************)
(*   Get information about members of an AS/400 file.               *)
(********************************************************************)
function cwbDB_RetrieveMemberInformation(
                             request:cwbDB_RequestHandle;
                             retrieveInformation:dword;
                             errorHandle:cwbSV_ErrHandle):integer; stdcall;

(********************************************************************)
(*   Get information about statements stored in a SQL package on    *)
(*   the AS/400.                                                    *)
(********************************************************************)
function cwbDB_RetrievePackageStatementInformation(
                             request:cwbDB_RequestHandle;
                             retrieveInformation:dword;
                             errorHandle:cwbSV_ErrHandle):integer; stdcall;

(********************************************************************)
(*   Get information about primary keys for an AS/400 file.         *)
(********************************************************************)
function cwbDB_RetrievePrimaryKeyInformation(
                             request:cwbDB_RequestHandle;
                             retrieveInformation:dword;
                             errorHandle:cwbSV_ErrHandle):integer; stdcall;

(********************************************************************)
(*   Get information about a relational database on the AS/400.     *)
(********************************************************************)
function cwbDB_RetrieveRDBInformation(
                             request:cwbDB_RequestHandle;
                             retrieveInformation:dword;
                             errorHandle:cwbSV_ErrHandle):integer; stdcall;

(********************************************************************)
(*   Get information about the record formats for an AS/400 file.   *)
(********************************************************************)
function cwbDB_RetrieveRecordFormatInformation(
                             request:cwbDB_RequestHandle;
                             retrieveInformation:dword;
                             errorHandle:cwbSV_ErrHandle):integer; stdcall;

(********************************************************************)
(*   Get information about special columns for an AS/400 file.      *)
(********************************************************************)
function cwbDB_RetrieveSpecialColumnInformation(
                             request:cwbDB_RequestHandle;
                             retrieveInformation:dword;
                             errorHandle:cwbSV_ErrHandle):integer; stdcall;

(********************************************************************)
(*   Get information about a SQL package on the AS/400.             *)
(********************************************************************)
function cwbDB_RetrieveSQLPackageInformation(
                             request:cwbDB_RequestHandle;
                             retrieveInformation:dword;
                             errorHandle:cwbSV_ErrHandle):integer; stdcall;

(********************************************************************)
(*   Instructs the API to return the data that is in the result set *)
(*   for the operation.                                             *)
(********************************************************************)
function cwbDB_ReturnData(
                             request:cwbDB_RequestHandle;
                             data:cwbDB_DataHandle;
                             indicators:cwbDB_DataHandle;
                             formatHandle:cwbDB_FormatHandle;
                             errorHandle:cwbSV_ErrHandle):integer; stdcall;

(********************************************************************)
(*   Instructs the API to return the format of the data to be       *)
(*   returned.                                                      *)
(********************************************************************)
function cwbDB_ReturnDataFormat(
                             request:cwbDB_RequestHandle;
                             formatHandle:cwbDB_FormatHandle;
                             errorHandle:cwbSV_ErrHandle):integer; stdcall;

(********************************************************************)
(*   Instructs the API to return host error information when a      *)
(*   function is performed on the host server.                      *)
(********************************************************************)
function cwbDB_ReturnHostErrorInfo(
                             request:cwbDB_RequestHandle;
                             var hostErrorClass:word;
                             var hostErrorCode:integer;
                             hostMsgID:cwbDB_DataHandle;
                             firstLevelMessageText:cwbDB_DataHandle;
                             secondLevelMessageText:cwbDB_DataHandle;
                             errorHandle:cwbSV_ErrHandle):integer; stdcall;

(********************************************************************)
(*   Instructs the API to return the format of the parameter marker *)
(*   data for a SQL statement.                                      *)
(********************************************************************)
function cwbDB_ReturnParameterMarkerFormat(
                             request:cwbDB_RequestHandle;
                             formatHandle:cwbDB_FormatHandle;
                             errorHandle:cwbSV_ErrHandle):integer; stdcall;
(********************************************************************)
(*   Instructs the API to return the SQL Communication Area         *)
(*   (SQLCA).                                                       *)
(********************************************************************)
function cwbDB_ReturnSQLCA(
                             request:cwbDB_RequestHandle;
                             var sqlca:cwbDB_SQLCA;
                             errorHandle:cwbSV_ErrHandle):integer; stdcall;

(********************************************************************)
(*   Perform a rollback operation.                                  *)
(********************************************************************)
function cwbDB_Rollback(
                             request:cwbDB_RequestHandle;
                             errorHandle:cwbSV_ErrHandle):integer; stdcall;

(********************************************************************)
(*   Set the public authority for a file that will be created       *)
(*   through the API.                                               *)
(********************************************************************)
function cwbDB_SetAuthority(
                             request:cwbDB_RequestHandle;
                             authority:word;
                             errorHandle:cwbSV_ErrHandle):integer; stdcall;

(********************************************************************)
(*   Set the name of a base file for creating a new file with the   *)
(*   same format through the API.                                   *)
(********************************************************************)
// warning UNICODE !
function cwbDB_SetBaseFile(
                             request:cwbDB_RequestHandle;
                             const baseLibraryName:pchar;
                             const baseFileName:pchar;
                             errorHandle:cwbSV_ErrHandle):integer; stdcall;

(********************************************************************)
(*   Set the number of rows to be blocked together when fetching    *)
(*   data.                                                          *)
(********************************************************************)
function cwbDB_SetBlockCount(
                             request:cwbDB_RequestHandle;
                             blockCount:dword;
                             errorHandle:cwbSV_ErrHandle):integer; stdcall;

(********************************************************************)
(*   Sets the information for a column description for string data. *)
(********************************************************************)
function cwbDB_SetClientColumnToNumeric(
                             format:cwbDB_FormatHandle;
                             columnPosition:dword;
                             columnType:shortint;
                             columnLength:dword;
                             columnPrecision:word;
                             columnScale:word;
                             errorHandle:cwbSV_ErrHandle):integer; stdcall;

(********************************************************************)
(*   Sets the information for a column description for string data. *)
(********************************************************************)
function cwbDB_SetClientColumnToString(
                             format:cwbDB_FormatHandle;
                             columnPosition:dword;
                             columnType:shortint;
                             columnLength:dword;
                             columnCCSID:word;
                             errorHandle:cwbSV_ErrHandle):integer; stdcall;

(********************************************************************)
(*   Sets the information for a parameter description for string    *)
(*   data.                                                          *)
(********************************************************************)
function cwbDB_SetClientParameterToNumeric(
                             format:cwbDB_FormatHandle;
                             parameterPosition:dword;
                             parameterType:shortint;
                             parameterLength:dword;
                             parameterPrecision:word;
                             parameterScale:word;
                             errorHandle:cwbSV_ErrHandle):integer; stdcall;

(********************************************************************)
(*   Sets the information for a parameter description for string    *)
(*   data.                                                          *)
(********************************************************************)
function cwbDB_SetClientParameterToString(
                             format:cwbDB_FormatHandle;
                             parameterPosition:dword;
                             parameterType:shortint;
                             parameterLength:dword;
                             parameterCCSID:word;
                             errorHandle:cwbSV_ErrHandle):integer; stdcall;

(********************************************************************)
(*   Set the commitment level for the database server to use when   *)
(*   accessing data.                                                *)
(********************************************************************)
function cwbDB_SetCommitmentControl(
                             connection:cwbDB_ConnectionHandle;
                             commitmentLevel:word;
                             errorHandle:cwbSV_ErrHandle):integer; stdcall;

(********************************************************************)
(*   Sets the indicator that says whether data is to be converted   *)
(*   between the client and host format.                            *)
(********************************************************************)
function cwbDB_SetConversionIndicator(
                             format:cwbDB_FormatHandle;
                             conversionIndicator:cwb_Boolean;
                             errorHandle:cwbSV_ErrHandle):integer; stdcall;

(********************************************************************)
(*   Sets the indicator that says whether data marked with CCSID    *)
(*   65535 is to be converted between ASCII and EBCDIC. Data tagged *)
(*   with CCSID 65535 are binary data. Selecting to convert this    *)
(*   this data may cause conversion errors and possible data        *)
(*   integrity problems. USE THIS API AT YOUR OWN RISK.             *)
(*                                                                  *)
(*   Having said that, it is important to note that some older data *)
(*   may have text data tagged with CCSID 65535. Also, some AS/400  *)
(*   tools still write data to files using CCSID 65535. Therefore,  *)
(*   there may be appropriate times to use this API.                *)
(********************************************************************)
function cwbDB_SetConvert65535(
                             connection:cwbDB_ConnectionHandle;
                             convert65535indicator:cwb_Boolean;
                             errorHandle:cwbSV_ErrHandle):integer; stdcall;

(********************************************************************)
(*   Set the statement name to be used for this request.            *)
(********************************************************************)
// warning ! UNICODE
function cwbDB_SetCursorName(
                             request:cwbDB_RequestHandle;
                             const cursorName:pchar;
                             errorHandle:cwbSV_ErrHandle):integer; stdcall;
(********************************************************************)
(*   Set the format for date data returned from the AS/400.         *)
(*   Date data on the AS/400 are stored encoded and are             *)
(*   returned to the client as character strings. These             *)
(*   character strings can be formatted in eight different          *)
(*   ways:                                                          *)
(*                                                                  *)
(*    Format name          Format          Example                  *)
(*    ---------------      ----------      ---------------          *)
(*    Julian               yy/ddd          87/253                   *)
(*    month day year       mm/dd/yy        10/12/87                 *)
(*    day month year       dd/mm/yy        12/10/87                 *)
(*    year month day       yy/mm/dd        87/10/12                 *)
(*    USA                  mm/dd/yyyy      10/12/1987               *)
(*    ISO                  yyyy-mm-dd      1987-10-12               *)
(*    IBM Japan            yyyy-mm-dd      1987-10-12               *)
(*    IBM Europe           dd.mm.yyyy      12.10.1987               *)
(********************************************************************)
function cwbDB_SetDateFormat(
                             connection:cwbDB_ConnectionHandle;
                             dateFormat:word;
                             errorHandle:cwbSV_ErrHandle):integer; stdcall;

(********************************************************************)
(*   Set the character which separates the elements of date data    *)
(*   returned from the AS/400.                                      *)
(*                                                                  *)
(*   Date data on the AS/400 are stored encoded and are             *)
(*   returned to the client as character strings. These             *)
(*   character strings can have one of five different date          *)
(*   separator characters:                                          *)
(*                                                                  *)
(*    Date separator       Character       Example                  *)
(*    ---------------      ----------      ---------------          *)
(*    Slash                /               03/17/94                 *)
(*    Dash                 -               03-17-94                 *)
(*    Period               .               03.17.94                 *)
(*    Comma                ,               03,17,94                 *)
(*    Blank                                03 17 94                 *)
(********************************************************************)
function cwbDB_SetDateSeparator(
                             connection:cwbDB_ConnectionHandle;
                             dateSeparator:word;
                             errorHandle:cwbSV_ErrHandle):integer; stdcall;

(********************************************************************)
(*   Set the character which separates the elements of decimal      *)
(*   data returned from the AS/400.                                 *)
(*                                                                  *)
(*    Decimal separator      Character       Example                *)
(*    -----------------      ----------      ---------------        *)
(*    Period                 .               123.45                 *)
(*    Comma                  ,               123,45                 *)
(********************************************************************)
function cwbDB_SetDecimalSeparator(
                             connection:cwbDB_ConnectionHandle;
                             decimalSeparator:word;
                             errorHandle:cwbSV_ErrHandle):integer; stdcall;

(********************************************************************)
(*   Set the describe option to determine what data is to be        *)
(*   returned as a result of a describe.                            *)
(********************************************************************)
function cwbDB_SetDescribeOption(
                             request:cwbDB_RequestHandle;
                             describeOption:word;
                             errorHandle:cwbSV_ErrHandle):integer; stdcall;

(********************************************************************)
(*   After using the cwbDB_SetScrollableCursor, this API is used    *)
(*   to indicate how to scroll through the data.                    *)
(********************************************************************)
function cwbDB_SetFetchScrollOptions(
                             request:cwbDB_RequestHandle;
                             scrollType:word;
                             relativeDistance:dword;
                             errorHandle:cwbSV_ErrHandle):integer; stdcall;

(********************************************************************)
(*   Set the field name to be used in a catalog request.            *)
(********************************************************************)
// warning ! UNICODE
function cwbDB_SetFieldName(
                             request:cwbDB_RequestHandle;
                             const fieldName:pchar;
                             errorHandle:cwbSV_ErrHandle):integer; stdcall;

(********************************************************************)
(*   Set the file attributes to be used as a qualifier for a list   *)
(*   request.                                                       *)
(********************************************************************)
function cwbDB_SetFileAttributes(
                             request:cwbDB_RequestHandle;
                             fileAttributes:dword;
                             errorHandle:cwbSV_ErrHandle):integer; stdcall;

(********************************************************************)
(*   Set the file name to be used as a qualifier for a list         *)
(*   request.  This is the short file name (system name).           *)
(********************************************************************)
// warning ! UNICODE
function cwbDB_SetFileName(
                             request:cwbDB_RequestHandle;
                             const fileName:pchar;
                             errorHandle:cwbSV_ErrHandle):integer; stdcall;

(********************************************************************)
(*   Set the text description for a file that will be created       *)
(*   through the API.                                               *)
(********************************************************************)
// warning ! UNICODE
function cwbDB_SetFileText(
                             request:cwbDB_RequestHandle;
                             const fileText:pchar;
                             errorHandle:cwbSV_ErrHandle):integer; stdcall;

(********************************************************************)
(*   Set the file type to be used as a qualifier for a list         *)
(*   request.                                                       *)
(********************************************************************)
function cwbDB_SetFileType(
                             request:cwbDB_RequestHandle;
                             fileType:word;
                             errorHandle:cwbSV_ErrHandle):integer; stdcall;

(********************************************************************)
(*   Set the foreign key file name to be used in a request.         *)
(********************************************************************)
// warning ! UNICODE
function cwbDB_SetForeignKeyFileName(
                             request:cwbDB_RequestHandle;
                             const fileName:pchar;
                             errorHandle:cwbSV_ErrHandle):integer; stdcall;

(********************************************************************)
(*   Set the foreign key library name to be used in a request.      *)
(********************************************************************)
// warning ! UNICODE
function cwbDB_SetForeignKeyLibName(
                             request:cwbDB_RequestHandle;
                             const libName:pchar;
                             errorHandle:cwbSV_ErrHandle):integer; stdcall;

(********************************************************************)
(*   Set the record format name to be used in a request.            *)
(********************************************************************)
// warning ! UNICODE
function cwbDB_SetFormatName(
                             request:cwbDB_RequestHandle;
                             const formatName:pchar;
                             errorHandle:cwbSV_ErrHandle):integer; stdcall;

(********************************************************************)
(*   This API instructs SQL how to treat active statements (open    *)
(*   cursors and prepared dynamic SQL statements) when a commit or  *)
(*   rollback operation is performed.  CWBDB_HOLD indicates that    *)
(*   open cursors and prepared dynamic SQL statements will be       *)
(*   preserved.  CWBDB_WORK will cause open cursors to be closed    *)
(*   and prepared dynamic SQL statement to be destroyed.            *)
(********************************************************************)
function cwbDB_SetHoldIndicator(
                             request:cwbDB_RequestHandle;
                             holdIndicator:word;
                             errorHandle:cwbSV_ErrHandle):integer; stdcall;

(********************************************************************)
(*   Set an indicator that says whether to ignore or correct        *)
(*   zoned decimal data errors.                                     *)
(********************************************************************)
function cwbDB_SetIgnoreDecimalDataError(
                             connection:cwbDB_ConnectionHandle;
                             ignoreDecimalError:word;
                             errorHandle:cwbSV_ErrHandle):integer; stdcall;

(********************************************************************)
(*   Set the type of index criteria to be used in a catalog request.*)
(********************************************************************)
function cwbDB_SetIndexType(
                             request:cwbDB_RequestHandle;
                             indexType:word;
                             errorHandle:cwbSV_ErrHandle):integer; stdcall;

(********************************************************************)
(*   Set the library name to be used for the current database       *)
(*   request.                                                       *)
(********************************************************************)
// warning ! UNICODE
function cwbDB_SetLibraryName(
                             request:cwbDB_RequestHandle;
                             const libraryName:pchar;
                             errorHandle:cwbSV_ErrHandle):integer; stdcall;

(********************************************************************)
(*   Set the long file name to be used as a qualifier for a list    *)
(*   request.                                                       *)
(********************************************************************)
// warning ! UNICODE
function cwbDB_SetLongFileName(
                             request:cwbDB_RequestHandle;
                             const longFileName:pchar;
                             errorHandle:cwbSV_ErrHandle):integer; stdcall;

(********************************************************************)
(*   Set the maximum number of members for creating a file          *)
(*   through the API.                                               *)
(********************************************************************)
function cwbDB_SetMaximumMembers(
                             request:cwbDB_RequestHandle;
                             maxMembers:shortint;
                             errorHandle:cwbSV_ErrHandle):integer; stdcall;

(********************************************************************)
(*   Set the member name to be used in a request.                   *)
(********************************************************************)
// warning ! UNICODE
function cwbDB_SetMemberName(
                             request:cwbDB_RequestHandle;
                             const memberName:pchar;
                             errorHandle:cwbSV_ErrHandle):integer; stdcall;

(********************************************************************)
(*   Set the text description for a member at will be added         *)
(*   through the API.                                               *)
(********************************************************************)
// warning ! UNICODE
function cwbDB_SetMemberText(
                             request:cwbDB_RequestHandle;
                             const memberText:pchar;
                             errorHandle:cwbSV_ErrHandle):integer; stdcall;
(********************************************************************)
(*   Set the naming convention (SQL or native AS/400) to be used by *)
(*   the database access server.                                    *)
(********************************************************************)
function cwbDB_SetNamingConvention(
                             connection:cwbDB_ConnectionHandle;
                             newNamingConvention:word;
                             errorHandle:cwbSV_ErrHandle):integer; stdcall;

(********************************************************************)
(*   Sets the National Language Sort Sequence (NLSS) attribute of   *)
(*   the Data Access server.                                        *)
(********************************************************************)
// warning ! UNICODE
function cwbDB_SetNLSS(
                             connection:cwbDB_ConnectionHandle;
                             NLSSTypeID:word;
                             const tableOrLangID:pchar;
                             const library_:pchar;
                             errorHandle:cwbSV_ErrHandle ):integer; stdcall;

(********************************************************************)
(*   Set the nullable indicator for a special column.               *)
(********************************************************************)
function cwbDB_SetNullable(
                             request:cwbDB_RequestHandle;
                             nullableInd:word;
                             errorHandle:cwbSV_ErrHandle):integer; stdcall;

(********************************************************************)
(*   Set the overriding library, file, and member for an override   *)
(*   database operation.                                            *)
(********************************************************************)
// warning ! UNICODE
function cwbDB_SetOverrideInformation(
                             request:cwbDB_RequestHandle;
                             const overrideLibraryName:pchar;
                             const overrideFileName:pchar;
                             const overrideMemberName:pchar;
                             errorHandle:cwbSV_ErrHandle):integer; stdcall;

(********************************************************************)
(*   Set the SQL package name for a database request.               *)
(********************************************************************)
// warning ! UNICODE
function cwbDB_SetPackageName(
                             request:cwbDB_RequestHandle;
                             const packageName:pchar;
                             errorHandle:cwbSV_ErrHandle):integer; stdcall;

(********************************************************************)
(*   Provides the data to be used for the parameter markers         *)
(*   contained in a prepared statement for a block of rows.         *)
(********************************************************************)
function cwbDB_SetParameterMarkerBlock(
                             request:cwbDB_RequestHandle;
                             numberOfRows:dword;
                             format:cwbDB_FormatHandle;
                             var dataPointer;
                             var indicators:shortint;
                             errorHandle:cwbSV_ErrHandle):integer; stdcall;

(********************************************************************)
(*   Provides the data to be used for the parameter markers         *)
(*   contained in a prepared statement.                             *)
(********************************************************************)
function cwbDB_SetParameterMarkers(
                             request:cwbDB_RequestHandle;
                             format:cwbDB_FormatHandle;
                             var dataBuffer;
                             var indicators:shortint;
                             errorHandle:cwbSV_ErrHandle):integer; stdcall;

(********************************************************************)
(*   Set the option for doing a normal or enhanced prepare.         *)
(*   Doing an enhanced prepare will search the specified SQL        *)
(*   package for the given statement.  If it is found, the          *)
(*   statement will be used.  If not, the statement will be         *)
(*   prepared.                                                      *)
(********************************************************************)
function cwbDB_SetPrepareOption(
                             request:cwbDB_RequestHandle;
                             prepareOption:word;
                             errorHandle:cwbSV_ErrHandle):integer; stdcall;

(********************************************************************)
(*   Set the primary key file name to be used in a request.         *)
(********************************************************************)
// warning ! UNICODE
function cwbDB_SetPrimaryKeyFileName(
                             request:cwbDB_RequestHandle;
                             const fileName:pchar;
                             errorHandle:cwbSV_ErrHandle):integer; stdcall;

(********************************************************************)
(*   Set the primary key library name to be used in a request.      *)
(********************************************************************)
// warning ! UNICODE
function cwbDB_SetPrimaryKeyLibName(
                             request:cwbDB_RequestHandle;
                             const libName:pchar;
                             errorHandle:cwbSV_ErrHandle):integer; stdcall;

(********************************************************************)
(*   Set the Relational Database (RDB) name for a catalog request.  *)
(*   This is the RDB for which information is being requested.      *)
(********************************************************************)
// warning ! UNICODE
function cwbDB_SetRDBName(
                             request:cwbDB_RequestHandle;
                             const RDBName:pchar;
                             errorHandle:cwbSV_ErrHandle):integer; stdcall;

(********************************************************************)
(*   Set the record length in preparation for creating a file       *)
(*   through the API.                                               *)
(********************************************************************)
function cwbDB_SetRecordLength(
                             request:cwbDB_RequestHandle;
                             recordLength:dword;
                             errorHandle:cwbSV_ErrHandle):integer; stdcall;

(********************************************************************)
(*   Indicate whether the cursor used by this request is scrollable *)
(*   or not.                                                        *)
(********************************************************************)
function cwbDB_SetScrollableCursor(
                             request:cwbDB_RequestHandle;
                             scrollIndicator:word;
                             errorHandle:cwbSV_ErrHandle):integer; stdcall;

(********************************************************************)
(*   Set the statement name to be used for this request.            *)
(********************************************************************)
// warning ! UNICODE
function cwbDB_SetStatementName(
                             request:cwbDB_RequestHandle;
                             const statementName:pchar;
                             errorHandle:cwbSV_ErrHandle):integer; stdcall;

(********************************************************************)
(*   Set the statement text to be used for this request.            *)
(********************************************************************)
// warning ! UNICODE
function cwbDB_SetStatementText(
                             request:cwbDB_RequestHandle;
                             const statementText:pchar;
                             errorHandle:cwbSV_ErrHandle):integer; stdcall;

(********************************************************************)
(*   Set the type of SQL statement for which information is being   *)
(*   requested .                                                    *)
(********************************************************************)
function cwbDB_SetStatementType(
                             request:cwbDB_RequestHandle;
                             statementType:word;
                             errorHandle:cwbSV_ErrHandle):integer; stdcall;

(********************************************************************)
(*   Starts the communication between the client and the AS/400     *)
(*   server.                                                        *)
(********************************************************************)
function cwbDB_StartServer(
                             connection:cwbDB_ConnectionHandle;
                             errorHandle:cwbSV_ErrHandle):integer; stdcall;

(********************************************************************)
(*   Ends the communication between the client and the AS/400       *)
(*   server.                                                        *)
(********************************************************************)
function cwbDB_StopServer(
                             connection:cwbDB_ConnectionHandle;
                             errorHandle:cwbSV_ErrHandle):integer; stdcall;

(********************************************************************)
(*   Sends the current parameters to the AS/400 to the stored by    *)
(*   the database access server.  Those parameters can then be      *)
(*   used by the request on subsequent funtion calls.               *)
(********************************************************************)
function cwbDB_StoreRequestParameters(
                             request:cwbDB_RequestHandle;
                             errorHandle:cwbSV_ErrHandle):integer; stdcall;

(********************************************************************)
(*   Set the format for time data returned from the AS/400.         *)
(*   Time data on the AS/400 are stored encoded and are             *)
(*   returned to the client as character strings. These             *)
(*   character strings can be formatted in five different           *)
(*   ways:                                                          *)
(*                                                                  *)
(*    Format name            Format            Example              *)
(*    ---------------        ----------        ---------------      *)
(*    Hours minutes seconds  hh:mm:ss          13:30:05             *)
(*    USA                    hh:mm AM or PM    1:30 PM              *)
(*    ISO                    hh.mm.ss          13:30:05             *)
(*    IBM Europe             hh.mm.ss          13:30:05             *)
(*    IBM Japan              hh:mm:ss          13:30:05             *)
(********************************************************************)
function cwbDB_SetTimeFormat(
                             connection:cwbDB_ConnectionHandle;
                             timeFormat:word;
                             errorHandle:cwbSV_ErrHandle):integer; stdcall;

(********************************************************************)
(*   Set the character which separates the elements of time data    *)
(*   returned from the AS/400.                                      *)
(*                                                                  *)
(*   Time data on the AS/400 are stored encoded and are             *)
(*   returned to the client as character strings. These             *)
(*   character strings can have one of four different time          *)
(*   separator characters:                                          *)
(*                                                                  *)
(*    Date separator       Character       Example                  *)
(*    ---------------      ----------      ---------------          *)
(*    Colon                :               11:10:03                 *)
(*    Period               .               11.10.03                 *)
(*    Comma                ,               11,10,03                 *)
(*    Blank                                11 10 03                 *)
(********************************************************************)
function cwbDB_SetTimeSeparator(
                             connection:cwbDB_ConnectionHandle;
                             timeSeparator:word;
                             errorHandle:cwbSV_ErrHandle):integer; stdcall;

{ --- CBWCO.H --- }
(*------------------------------------------------------------------*)
(* Component CO errors based on CWB_LAST (in CWB.H)                 *)
(*------------------------------------------------------------------*)
const
 CWBCO_START   =CWB_LAST+1;

 CWBCO_END_OF_LIST                     =CWBCO_START+1;
 CWBCO_DEFAULT_SYSTEM_NOT_DEFINED      =CWBCO_START+2;
 CWBCO_DEFAULT_SYSTEM_NOT_CONFIGURED   =CWBCO_START+3;
 CWBCO_SYSTEM_NOT_CONNECTED            =CWBCO_START+4;
 CWBCO_SYSTEM_NOT_CONFIGURED           =CWBCO_START+5;
 CWBCO_NO_USER_ID                      =CWBCO_START+6;
 CWBCO_INTERNAL_ERROR                  =CWBCO_START+7;
 CWBCO_NO_SUCH_ENVIRONMENT             =CWBCO_START+8;
(*------------------------------------------------------------------*)
(* Definitions to use when specifying which User ID you mean        *)
(*------------------------------------------------------------------*)
 CWBCO_DEFAULT_USER_ID                 =0;
 CWBCO_CURRENT_USER_ID                 =1;
(*------------------------------------------------------------------*)
(* TYPEDEFS:                                                        *)
(*------------------------------------------------------------------*)
type
 cwbCO_SysListHandle=cwb_Handle;

(********************************************************************)
(*   Creates a handle to list of configured system names in the     *)
(*   environment currently in use.                                  *)
(********************************************************************)
function cwbCO_CreateSysListHandle(
                             var listHandle:cwbCO_SysListHandle;
                             errorHandle:cwbSV_ErrHandle):integer; stdcall;

(********************************************************************)
(*   Creates a handle to list of configured system names of the     *)
(*   specified environment.                                         *)
(********************************************************************)
// warning ! UNICODE
function cwbCO_CreateSysListHandleEnv(
                             var listHandle:cwbCO_SysListHandle;
                             errorHandle:cwbSV_ErrHandle;
                             const pEnvironment:pchar ):integer; stdcall;

(********************************************************************)
(*   Deletes a handle to a list of configured system names.  This   *)
(*   must be done last when finished using the system name list.    *)
(********************************************************************)
function cwbCO_DeleteSysListHandle(
                             listHandle:cwbCO_SysListHandle):integer; stdcall;

(********************************************************************)
(*   Get the name of the default system for Client Access.          *)
(********************************************************************)
// warning ! UNICODE
function cwbCO_GetDefaultSysName(
                             defaultSystemName:pchar;
                             bufferSize:dword;
                             var needed:dword;
                             errorHandle:cwbSV_ErrHandle):integer; stdcall;

(********************************************************************)
(*   Get the name of the next system from a list of systems.        *)
(********************************************************************)
// warning ! UNICODE
function cwbCO_GetNextSysName(
                             listHandle:cwbCO_SysListHandle;
                             systemName:pchar;
                             buffersize:dword;
                             var needed:dword):integer; stdcall;

(********************************************************************)
(*   Gets the number of system names in the list.                   *)
(********************************************************************)
function cwbCO_GetSysListSize(
                             listHandle:cwbCO_SysListHandle;
                             var listSize:dword):integer; stdcall;

(********************************************************************)
(*   Get the name of the connected system corresponding to the      *)
(*   index.                                                         *)
(********************************************************************)
// warning ! UNICODE
function cwbCO_GetConnectedSysName(
                             systemName:pchar;
                             var bufferSize:dword;
                             index:dword):integer; stdcall;

(********************************************************************)
(*   Check if the input system is configured in the environment     *)
(*   currently in use.                                              *)
(********************************************************************)
// warning ! UNICODE
function cwbCO_IsSystemConfigured(const systemName:Pchar):cwb_Boolean; stdcall;

(********************************************************************)
(*   Check if the input system is configured in the environment     *)
(*   specified.                                                     *)
(********************************************************************)
// warning ! UNICODE
function cwbCO_IsSystemConfiguredEnv(const systemName,pEnvironment:pchar):cwb_Boolean; stdcall;

(********************************************************************)
(*   Check if the input system is currently connected.              *)
(********************************************************************)
// warning ! UNICODE
function cwbCO_IsSystemConnected(const systemName:Pchar):cwb_Boolean; stdcall;

(********************************************************************)
(*   Get signon or default user ID of the input system as it is     *)
(*   configured and possibly connected in the currently active      *)
(*   environment.                                                   *)
(********************************************************************)
// warning ! UNICODE !
function cwbCO_GetUserID(const sysname:pchar;
                         userID:pchar;
                         userID_Type:dword; // unsigned int ???
                         var buffersize:dword):integer; stdcall;

(********************************************************************)
(*   Get the number of active conversations of the system.          *)
(********************************************************************)
// warning ! UNICODE
function cwbCO_GetActiveConversations(const systemName:pchar):integer; stdcall;

(********************************************************************)
(*   Get the version and release level of the host.                 *)
(********************************************************************)
// warning ! UNICODE
function cwbCO_GetHostVersion(const system:pchar; var version,release:dword):integer; stdcall;
//                             unsigned int * version,
//                             unsigned int * release ):integer; stdcall;

(********************************************************************)
(*   Get the number of Client Access environments that exist.  This *)
(*   includes both the active and all non-active environments.      *)
(********************************************************************)
function cwbCO_GetNumberOfEnvironments(var numberOfEnv:dword):integer; stdcall;

(********************************************************************)
(*   Get the name of the environment corresponding to the index.    *)
(********************************************************************)
// warning ! UNICODE
function cwbCO_GetEnvironmentName(
                             environmentName:pchar;
                             var bufferSize:dword;
                             index:dword):integer; stdcall;

(********************************************************************)
(*   Get the name of the environment currently active.              *)
(********************************************************************)
// warning ! UNICODE
function cwbCO_GetActiveEnvironment(
                             environmentName:pchar;
                             var bufferSize:dword):integer; stdcall;


//---CWBRC.H----
(*------------------------------------------------------------------*)
(* TYPEDEFS:                                                        *)
(*------------------------------------------------------------------*)
type
 cwbRC_SysHandle=cwb_Handle;
 cwbRC_PgmHandle=cwb_Handle;
(*------------------------------------------------------------------*)
(*                                                                  *)
(* Definitions for parameter types                                  *)
(*                                                                  *)
(*------------------------------------------------------------------*)
const
 CWBRC_INPUT      =1;
 CWBRC_OUTPUT     =2;
 CWBRC_INOUT      =3;

 CWBRC_TEXT_CONVERT          =$0030;
 CWBRC_TEXT_CONVERT_INPUT    =$0010;
 CWBRC_TEXT_CONVERT_OUTPUT   =$0020;
(*-------------------------------------------------------------------*)
(* Component RC errors based on CWB_LAST (in CWB.H)                  *)
(*-------------------------------------------------------------------*)

 CWBRC_START =CWB_LAST+1;

(*------------------------------------------------------------------*)
(* Invalid system handle                                            *)
(*------------------------------------------------------------------*)
 CWBRC_INVALID_SYSTEM_HANDLE    =CWBRC_START;

(*------------------------------------------------------------------*)
(* Invalid program handle                                           *)
(*------------------------------------------------------------------*)
 CWBRC_INVALID_PROGRAM          =CWBRC_START+1;

(*------------------------------------------------------------------*)
(* System name is too long or cannot be converted                   *)
(*------------------------------------------------------------------*)
 CWBRC_SYSTEM_NAME              =CWBRC_START+2;

(*------------------------------------------------------------------*)
(* Command string is too long or cannot be converted                *)
(*------------------------------------------------------------------*)
   CWBRC_COMMAND_STRING         =CWBRC_START+3;

(*------------------------------------------------------------------*)
(* program name is too long or cannot be converted                  *)
(*------------------------------------------------------------------*)
   CWBRC_PROGRAM_NAME           =CWBRC_START+4;

(*------------------------------------------------------------------*)
(* Library name is too long or cannot be converted                  *)
(*------------------------------------------------------------------*)
  CWBRC_LIBRARY_NAME            =CWBRC_START+5;

(*------------------------------------------------------------------*)
(* Invalid parameter type specified                                 *)
(*------------------------------------------------------------------*)
 CWBRC_INVALID_TYPE             =CWBRC_START+6;

(*------------------------------------------------------------------*)
(* Invalid parameter length                                         *)
(*------------------------------------------------------------------*)
 CWBRC_INVALID_PARM_LENGTH      =CWBRC_START+7;

(*------------------------------------------------------------------*)
(* Invalid parameter specified                                      *)
(*------------------------------------------------------------------*)
 CWBRC_INVALID_PARM             =CWBRC_START+8;

(*------------------------------------------------------------------*)
(* Attempt to add more than 25 paramters to a program               *)
(*------------------------------------------------------------------*)
 CWBRC_TOO_MANY_PARMS           =CWBRC_START+9;

(*------------------------------------------------------------------*)
(* Index is out of range for this program                           *)
(*------------------------------------------------------------------*)
 CWBRC_INDEX_RANGE_ERROR        =CWBRC_START+10;

(*------------------------------------------------------------------*)
(* Command rejected by user exit program                            *)
(*------------------------------------------------------------------*)
 CWBRC_REJECTED_USER_EXIT       =CWBRC_START+11;

(*------------------------------------------------------------------*)
(* Error in user exit program                                       *)
(*------------------------------------------------------------------*)
 CWBRC_USER_EXIT_ERROR          =CWBRC_START+12;

(*------------------------------------------------------------------*)
(* Command failed                                                   *)
(*------------------------------------------------------------------*)
 CWBRC_COMMAND_FAILED           =CWBRC_START+13;

(*------------------------------------------------------------------*)
(* Program not found or could not be accessed                       *)
(*------------------------------------------------------------------*)
 CWBRC_PROGRAM_NOT_FOUND        =CWBRC_START+14;

(*------------------------------------------------------------------*)
(* Error occurred when calling the program                          *)
(*------------------------------------------------------------------*)
 CWBRC_PROGRAM_ERROR            =CWBRC_START+15;

(*------------------------------------------------------------------*)
(* Command string is longer than the maximum of 6000 characters     *)
(*------------------------------------------------------------------*)
 CWBRC_COMMAND_TOO_LONG         =CWBRC_START+16;

(*------------------------------------------------------------------*)
(* Unexpected error                                                 *)
(*------------------------------------------------------------------*)
 CWBRC_UNEXPECTED_ERROR         =CWBRC_START+99;
(********************************************************************)
(*   Add a parameter to the program that is identified by the       *)
(*   handle.  This function should be called once for each          *)
(*   parameter that is to be added to the program.  When the        *)
(*   program is called the parameters will be in the same order     *)
(*   that they are added using this function.                       *)
(********************************************************************)
function  cwbRC_AddParm(
                             program_:cwbRC_PgmHandle;
                             type_:word;
                             length:dword;
                             const parameter:pchar):integer; stdcall;


(********************************************************************)
(*   Calls the program identified by the handle.  The return code   *)
(*   will indicate the success or failure of the program.           *)
(*   Additional messages can be returned by using the message       *)
(*   handle that is returned.                                       *)
(********************************************************************)
function  cwbRC_CallPgm(
                             system:cwbRC_SysHandle;
                             program_:cwbRC_PgmHandle;
                             msgHandle:cwbSV_ErrHandle):integer; stdcall;

(********************************************************************)
(*   This function creates a program object given a program and     *)
(*   library name.  The handle that is returned can be used to      *)
(*   add parameters to the program and then call the program.       *)
(********************************************************************)
// warning ! UNICODE
function  cwbRC_CreatePgm(
                              const programName:pchar;
                              const libraryName:pchar;
                              var program_:cwbRC_PgmHandle):integer; stdcall;
(********************************************************************)
(*   This function deletes the program object that is identified    *)
(*   by the handle provided.                                        *)
(********************************************************************)
function  cwbRC_DeletePgm(program_:cwbRC_PgmHandle):integer; stdcall;

(********************************************************************)
(*   Get the coded character set identifier (CCSID) associated with *)
(*   the current process.  This CCSID along with the host CCSID can *)
(*   be used to convert EBCDIC data returned by some AS/400 programs*)
(*   to ASCII data that can be used in client applications.         *)
(********************************************************************)
function  cwbRC_GetClientCCSID(
                             system:cwbRC_SysHandle;
                             var clientCCSID:dword):integer; stdcall;

(********************************************************************)
(*   Get the coded character set identifier (CCSID) associated with *)
(*   the AS/400 server job.  This CCSID along with the client CCSID *)
(*   can be used to convert EBCDIC data returned by some AS/400     *)
(*   programs to ASCII data that can be used in client applications.*)
(********************************************************************)
function  cwbRC_GetHostCCSID(
                             system:cwbRC_SysHandle;
                             var hostCCSID:dword):integer; stdcall;

(********************************************************************)
(*   Get the name of the library that was used when creating this   *)
(*   program object.                                                *)
(********************************************************************)
// warning ! UNICODE
function  cwbRC_GetLibName(
                             program_:cwbRC_PgmHandle;
                             libraryName:pchar):integer; stdcall;
(********************************************************************)
(*   Retrieve the parameter identified by the index.  The index     *)
(*   will range from 0 to the total number of parameters - 1.  This *)
(*   number can be obtained by calling the cwbRC_GetParmCount       *)
(*   API.                                                           *)
(********************************************************************)
function  cwbRC_GetParm(
                             program_:cwbRC_PgmHandle;
                             index:word;
                             var type_:word;
                             var length:dword;
                             var parameter:pchar):integer; stdcall;

(********************************************************************)
(*   Get the number of parameters for this program object.          *)
(********************************************************************)
function  cwbRC_GetParmCount(
                             program_:cwbRC_PgmHandle;
                             var count:word):integer; stdcall;

(********************************************************************)
(*   Get the name of the program that was used when creating this   *)
(*   program.                                                       *)
(********************************************************************)
// warning ! UNICODE
function  cwbRC_GetPgmName(
                             program_:cwbRC_PgmHandle;
                             programName:pchar):integer; stdcall;

(********************************************************************)
(*   Get the name of the system that was used when starting this    *)
(*   system.                                                        *)
(********************************************************************)
// warning ! UNICODE
function  cwbRC_GetSysName(
                             system:cwbRC_SysHandle;
                             systemName:pchar):integer; stdcall;

(********************************************************************)
(*   Issues the command on the system identified by the handle.     *)
(*   The return code will indicate success or failure of the        *)
(*   command.  Additional messages can be returned by using the     *)
(*   message handle that is returned.                               *)
(********************************************************************)
// warning ! UNICODE
function  cwbRC_RunCmd(
                             system:cwbRC_SysHandle;
                             const commandString:pchar;
                             msgHandle:cwbSV_ErrHandle):integer; stdcall;

(********************************************************************)
(*   Set the name of the library for this program object.           *)
(********************************************************************)
// warning ! UNICODE
function  cwbRC_SetLibName(
                             program_:cwbRC_PgmHandle;
                             const libraryName:pchar):integer; stdcall;

(********************************************************************)
(*   Set the parameter value identified by the index.  The index    *)
(*   will range from 0 to the total number of parameters - 1.  This *)
(*   number can be obtained by calling the cwbRC_GetParmCount       *)
(*   API.  Note that this function is to be used to change a        *)
(*   parameter.  Use cwbRC_AddParm to create the parameter.         *)
(********************************************************************)
function  cwbRC_SetParm(
                             program_:cwbRC_PgmHandle;
                             index:word;
                             type_:word;
                             length:dword;
                             const parameter:pchar):integer; stdcall;

(********************************************************************)
(*   Set the name of the program for this program object.           *)
(********************************************************************)
// warning ! UNICODE
function  cwbRC_SetPgmName(
                             program_:cwbRC_PgmHandle;
                             const programName:pchar):integer; stdcall;

(********************************************************************)
(*   This function starts a conversation with the specified system. *)
(*   If the conversation is successfully started, a handle is       *)
(*   returned.  Use this handle with all subsequent calls to        *)
(*   issue commands or call programs.  When the conversation is     *)
(*   no longer needed, use the handle with the API,                 *)
(*   cwbRC_StopSys to end the conversation.                         *)
(*   The cwbRC_StartSys API may be called multiple times within an  *)
(*   application.  If the application name is set to NULL, a new    *)
(*   conversation is started each time the API is called.  If the   *)
(*   application name is set, the same system handle is returned    *)
(*   each time this function is called.                             *)
(********************************************************************)
// warning ! UNICODE
function  cwbRC_StartSys(
                             const systemName:pchar;
                             const appName:pchar;
                             var system:cwbRC_SysHandle):integer; stdcall;

(********************************************************************)
(*   This function stops a conversation with the system specified   *)
(*   by the handle.  This handle can no longer be used to issue     *)
(*   program calls or commands.                                     *)
(********************************************************************)
function  cwbRC_StopSys(
                             system:cwbRC_SysHandle):integer; stdcall;

implementation

const cwbSV='CWBSV.DLL';

function cwbSV_ClearServiceFile; stdcall; external cwbSV;
function cwbSV_CloseServiceFile; stdcall; external cwbSV;
function cwbSV_CreateErrHandle; stdcall; external cwbSV;
function cwbSV_CreateMessageTextHandle; stdcall; external cwbSV;
function cwbSV_CreateServiceRecHandle; stdcall; external cwbSV;
function cwbSV_CreateTraceAPIHandle; stdcall; external cwbSV;
function cwbSV_CreateTraceDataHandle; stdcall; external cwbSV;
function cwbSV_CreateTraceSPIHandle; stdcall; external cwbSV;
function cwbSV_DeleteErrHandle; stdcall; external cwbSV;
function cwbSV_DeleteMessageTextHandle; stdcall; external cwbSV;
function cwbSV_DeleteServiceRecHandle; stdcall; external cwbSV;
function cwbSV_DeleteTraceAPIHandle; stdcall; external cwbSV;
function cwbSV_DeleteTraceDataHandle; stdcall; external cwbSV;
function cwbSV_DeleteTraceSPIHandle; stdcall; external cwbSV;
function cwbSV_GetComponent; stdcall; external cwbSV;
function cwbSV_GetCreatedBy; stdcall; external cwbSV;
function cwbSV_GetCurrentFix; stdcall; external cwbSV;
function cwbSV_GetDateStamp; stdcall; external cwbSV;
function cwbSV_GetErrClass; stdcall; external cwbSV;
function cwbSV_GetErrClassIndexed; stdcall; external cwbSV;
function cwbSV_GetErrCount; stdcall; external cwbSV;
function cwbSV_GetErrText; stdcall; external cwbSV;
function cwbSV_GetErrTextIndexed; stdcall; external cwbSV;
function cwbSV_GetFailMethod; stdcall; external cwbSV;
function cwbSV_GetFailModule; stdcall; external cwbSV;
function cwbSV_GetFailPathName; stdcall; external cwbSV;
function cwbSV_GetFailProductID; stdcall; external cwbSV;
function cwbSV_GetFailVersion; stdcall; external cwbSV;
function cwbSV_GetMaxRecordSize; stdcall; external cwbSV;
function cwbSV_GetMessageText; stdcall; external cwbSV;
function cwbSV_GetOriginSystemID; stdcall; external cwbSV;
function cwbSV_GetOriginSystemIPAddr; stdcall; external cwbSV;
function cwbSV_GetPreviousFix; stdcall; external cwbSV;
function cwbSV_GetProblemID; stdcall; external cwbSV;
function cwbSV_GetProblemStatus; stdcall; external cwbSV;
function cwbSV_GetProblemText; stdcall; external cwbSV;
function cwbSV_GetProblemType; stdcall; external cwbSV;
function cwbSV_GetProduct; stdcall; external cwbSV;
function cwbSV_GetRecordCount; stdcall; external cwbSV;
function cwbSV_GetServiceFileName; stdcall; external cwbSV;
function cwbSV_GetServiceType; stdcall; external cwbSV;
function cwbSV_GetSeverity; stdcall; external cwbSV;
function cwbSV_GetSymptomString; stdcall; external cwbSV;
function cwbSV_GetTimeStamp; stdcall; external cwbSV;
function cwbSV_GetTraceAPIData; stdcall; external cwbSV;
function cwbSV_GetTraceAPIID; stdcall; external cwbSV;
function cwbSV_GetTraceAPIType; stdcall; external cwbSV;
function cwbSV_GetTraceData; stdcall; external cwbSV;
function cwbSV_GetTraceSPIData; stdcall; external cwbSV;
function cwbSV_GetTraceSPIID; stdcall; external cwbSV;
function cwbSV_GetTraceSPIType; stdcall; external cwbSV;
function cwbSV_LogAPIEntry; stdcall; external cwbSV;
function cwbSV_LogAPIExit; stdcall; external cwbSV;
function cwbSV_LogMessageText; stdcall; external cwbSV;
function cwbSV_LogSPIEntry; stdcall; external cwbSV;
function cwbSV_LogSPIExit; stdcall; external cwbSV;
function cwbSV_LogTraceData; stdcall; external cwbSV;
function cwbSV_OpenServiceFile; stdcall; external cwbSV;
function cwbSV_ReadNewestRecord; stdcall; external cwbSV;
function cwbSV_ReadOldestRecord; stdcall; external cwbSV;
function cwbSV_ReadPrevRecord; stdcall; external cwbSV;
function cwbSV_SetMessageComponent; stdcall; external cwbSV;
function cwbSV_SetMessageProduct; stdcall; external cwbSV;
function cwbSV_SetAPIComponent; stdcall; external cwbSV;
function cwbSV_SetAPIProduct; stdcall; external cwbSV;
function cwbSV_SetSPIComponent; stdcall; external cwbSV;
function cwbSV_SetSPIProduct; stdcall; external cwbSV;
function cwbSV_SetTraceComponent; stdcall; external cwbSV;
function cwbSV_SetTraceProduct; stdcall; external cwbSV;

const cwbDB='CWBDB.DLL';

function cwbDB_AddMember; stdcall; external cwbDB;
function cwbDB_ApplyAttributes; stdcall; external cwbDB;
function cwbDB_ClearMember; stdcall; external cwbDB;
function cwbDB_ClearPackage; stdcall; external cwbDB;
function cwbDB_Close; stdcall; external cwbDB;
function cwbDB_Commit; stdcall; external cwbDB;
function cwbDB_Connect; stdcall; external cwbDB;
function cwbDB_CreateCatalogRequestHandle; stdcall; external cwbDB;
function cwbDB_CreateConnectionHandle; stdcall; external cwbDB;
function cwbDB_CreateDataFormatHandle; stdcall; external cwbDB;
function cwbDB_CreateDataHandle; stdcall; external cwbDB;
function cwbDB_CreateDuplicateFile; stdcall; external cwbDB;
function cwbDB_CreateNDBRequestHandle; stdcall; external cwbDB;
function cwbDB_CreatePackage; stdcall; external cwbDB;
function cwbDB_CreateParameterMarkerFormatHandle; stdcall; external cwbDB;
function cwbDB_CreateSourcePhysicalFile; stdcall; external cwbDB;
function cwbDB_CreateSQLRequestHandle; stdcall; external cwbDB;
function cwbDB_DeleteCatalogRequestHandle; stdcall; external cwbDB;
function cwbDB_DeleteConnectionHandle; stdcall; external cwbDB;
function cwbDB_DeleteDataFormatHandle; stdcall; external cwbDB;
function cwbDB_DeleteDataHandle; stdcall; external cwbDB;
function cwbDB_DeleteFile; stdcall; external cwbDB;
function cwbDB_DeleteNDBRequestHandle; stdcall; external cwbDB;
function cwbDB_DeletePackage; stdcall; external cwbDB;
function cwbDB_DeleteParameterMarkerFormatHandle; stdcall; external cwbDB;
function cwbDB_DeleteSQLRequestHandle; stdcall; external cwbDB;
function cwbDB_Describe; stdcall; external cwbDB;
function cwbDB_DescribeParameterMarkers; stdcall; external cwbDB;
function cwbDB_DynamicStreamFetch; stdcall; external cwbDB;
function cwbDB_EndStreamFetch; stdcall; external cwbDB;
function cwbDB_Execute; stdcall; external cwbDB;
function cwbDB_ExecuteImmediate; stdcall; external cwbDB;
function cwbDB_ExtendedDynamicStreamFetch; stdcall; external cwbDB;
function cwbDB_Fetch; stdcall; external cwbDB;
function cwbDB_GetColumnCCSID; stdcall; external cwbDB;
function cwbDB_GetColumnCount; stdcall; external cwbDB;
function cwbDB_GetColumnLength; stdcall; external cwbDB;
function cwbDB_GetColumnName; stdcall; external cwbDB;
function cwbDB_GetColumnPrecision; stdcall; external cwbDB;
function cwbDB_GetColumnScale; stdcall; external cwbDB;
function cwbDB_GetColumnType; stdcall; external cwbDB;
function cwbDB_GetCommitmentControl; stdcall; external cwbDB;
function cwbDB_GetConversionIndicator; stdcall; external cwbDB;
function cwbDB_GetData; stdcall; external cwbDB;
function cwbDB_GetDataLength; stdcall; external cwbDB;
function cwbDB_GetDataPointer; stdcall; external cwbDB;
function cwbDB_GetDateFormat; stdcall; external cwbDB;
function cwbDB_GetDateSeparator; stdcall; external cwbDB;
function cwbDB_GetDecimalSeparator; stdcall; external cwbDB;
function cwbDB_GetIgnoreDecimalDataError; stdcall; external cwbDB;
function cwbDB_GetNamingConvention; stdcall; external cwbDB;
function cwbDB_GetParameterCCSID; stdcall; external cwbDB;
function cwbDB_GetParameterCount; stdcall; external cwbDB;
function cwbDB_GetParameterLength; stdcall; external cwbDB;
function cwbDB_GetParameterPrecision; stdcall; external cwbDB;
function cwbDB_GetParameterScale; stdcall; external cwbDB;
function cwbDB_GetParameterType; stdcall; external cwbDB;
function cwbDB_GetRowSize; stdcall; external cwbDB;
function cwbDB_GetSizeOfInputParameters; stdcall; external cwbDB;
function cwbDB_GetSizeOfOutputParameters; stdcall; external cwbDB;
function cwbDB_GetTimeFormat; stdcall; external cwbDB;
function cwbDB_GetTimeSeparator; stdcall; external cwbDB;
function cwbDB_IsParameterInput; stdcall; external cwbDB;
function cwbDB_IsParameterInputOutput; stdcall; external cwbDB;
function cwbDB_MoreStreamData; stdcall; external cwbDB;
function cwbDB_Open; stdcall; external cwbDB;
function cwbDB_OpenDescribeFetch; stdcall; external cwbDB;
function cwbDB_OverrideFile; stdcall; external cwbDB;
function cwbDB_Prepare; stdcall; external cwbDB;
function cwbDB_PrepareDescribe; stdcall; external cwbDB;
function cwbDB_PrepareDescribeOpenFetch; stdcall; external cwbDB;
function cwbDB_RemoveMember; stdcall; external cwbDB;
function cwbDB_RemoveOverride; stdcall; external cwbDB;
function cwbDB_RetrieveFieldInformation; stdcall; external cwbDB;
function cwbDB_RetrieveFileInformation; stdcall; external cwbDB;
function cwbDB_RetrieveForeignKeyInformation; stdcall; external cwbDB;
function cwbDB_RetrieveIndexInformation; stdcall; external cwbDB;
function cwbDB_RetrieveLibraryInformation; stdcall; external cwbDB;
function cwbDB_RetrieveMemberInformation; stdcall; external cwbDB;
function cwbDB_RetrievePackageStatementInformation; stdcall; external cwbDB;
function cwbDB_RetrievePrimaryKeyInformation; stdcall; external cwbDB;
function cwbDB_RetrieveRDBInformation; stdcall; external cwbDB;
function cwbDB_RetrieveRecordFormatInformation; stdcall; external cwbDB;
function cwbDB_RetrieveSpecialColumnInformation; stdcall; external cwbDB;
function cwbDB_RetrieveSQLPackageInformation; stdcall; external cwbDB;
function cwbDB_ReturnData; stdcall; external cwbDB;
function cwbDB_ReturnDataFormat; stdcall; external cwbDB;
function cwbDB_ReturnHostErrorInfo; stdcall; external cwbDB;
function cwbDB_ReturnParameterMarkerFormat; stdcall; external cwbDB;
function cwbDB_ReturnSQLCA; stdcall; external cwbDB;
function cwbDB_Rollback; stdcall; external cwbDB;
function cwbDB_SetAuthority; stdcall; external cwbDB;
function cwbDB_SetBaseFile; stdcall; external cwbDB;
function cwbDB_SetBlockCount; stdcall; external cwbDB;
function cwbDB_SetClientColumnToNumeric; stdcall; external cwbDB;
function cwbDB_SetClientColumnToString; stdcall; external cwbDB;
function cwbDB_SetClientParameterToNumeric; stdcall; external cwbDB;
function cwbDB_SetClientParameterToString; stdcall; external cwbDB;
function cwbDB_SetCommitmentControl; stdcall; external cwbDB;
function cwbDB_SetConversionIndicator; stdcall; external cwbDB;
function cwbDB_SetConvert65535; stdcall; external cwbDB;
function cwbDB_SetCursorName; stdcall; external cwbDB;
function cwbDB_SetDateFormat; stdcall; external cwbDB;
function cwbDB_SetDateSeparator; stdcall; external cwbDB;
function cwbDB_SetDecimalSeparator; stdcall; external cwbDB;
function cwbDB_SetDescribeOption; stdcall; external cwbDB;
function cwbDB_SetFetchScrollOptions; stdcall; external cwbDB;
function cwbDB_SetFieldName; stdcall; external cwbDB;
function cwbDB_SetFileAttributes; stdcall; external cwbDB;
function cwbDB_SetFileName; stdcall; external cwbDB;
function cwbDB_SetFileText; stdcall; external cwbDB;
function cwbDB_SetFileType; stdcall; external cwbDB;
function cwbDB_SetForeignKeyFileName; stdcall; external cwbDB;
function cwbDB_SetForeignKeyLibName; stdcall; external cwbDB;
function cwbDB_SetFormatName; stdcall; external cwbDB;
function cwbDB_SetHoldIndicator; stdcall; external cwbDB;
function cwbDB_SetIgnoreDecimalDataError; stdcall; external cwbDB;
function cwbDB_SetIndexType; stdcall; external cwbDB;
function cwbDB_SetLibraryName; stdcall; external cwbDB;
function cwbDB_SetLongFileName; stdcall; external cwbDB;
function cwbDB_SetMaximumMembers; stdcall; external cwbDB;
function cwbDB_SetMemberName; stdcall; external cwbDB;
function cwbDB_SetMemberText; stdcall; external cwbDB;
function cwbDB_SetNamingConvention; stdcall; external cwbDB;
function cwbDB_SetNLSS; stdcall; external cwbDB;
function cwbDB_SetNullable; stdcall; external cwbDB;
function cwbDB_SetOverrideInformation; stdcall; external cwbDB;
function cwbDB_SetPackageName; stdcall; external cwbDB;
function cwbDB_SetParameterMarkerBlock; stdcall; external cwbDB;
function cwbDB_SetParameterMarkers; stdcall; external cwbDB;
function cwbDB_SetPrepareOption; stdcall; external cwbDB;
function cwbDB_SetPrimaryKeyFileName; stdcall; external cwbDB;
function cwbDB_SetPrimaryKeyLibName; stdcall; external cwbDB;
function cwbDB_SetRDBName; stdcall; external cwbDB;
function cwbDB_SetRecordLength; stdcall; external cwbDB;
function cwbDB_SetScrollableCursor; stdcall; external cwbDB;
function cwbDB_SetStatementName; stdcall; external cwbDB;
function cwbDB_SetStatementText; stdcall; external cwbDB;
function cwbDB_SetStatementType; stdcall; external cwbDB;
function cwbDB_StartServer; stdcall; external cwbDB;
function cwbDB_StopServer; stdcall; external cwbDB;
function cwbDB_StoreRequestParameters; stdcall; external cwbDB;
function cwbDB_SetTimeFormat; stdcall; external cwbDB;
function cwbDB_SetTimeSeparator; stdcall; external cwbDB;

 const cwbCO='CWBCO.DLL';

function cwbCO_CreateSysListHandle; stdcall; external cwbCO;
function cwbCO_CreateSysListHandleEnv; stdcall; external cwbCO;
function cwbCO_DeleteSysListHandle; stdcall; external cwbCO;
function cwbCO_GetDefaultSysName; stdcall; external cwbCO;
function cwbCO_GetNextSysName; stdcall; external cwbCO;
function cwbCO_GetSysListSize; stdcall; external cwbCO;
function cwbCO_GetConnectedSysName; stdcall; external cwbCO;
function cwbCO_IsSystemConfigured; stdcall; external cwbCO;
function cwbCO_IsSystemConfiguredEnv; stdcall; external cwbCO;
function cwbCO_IsSystemConnected; stdcall; external cwbCO;
function cwbCO_GetUserID; stdcall; external cwbCO;
function cwbCO_GetActiveConversations; stdcall; external cwbCO;
function cwbCO_GetHostVersion; stdcall; external cwbCO;
function cwbCO_GetNumberOfEnvironments; stdcall; external cwbCO;
function cwbCO_GetEnvironmentName; stdcall; external cwbCO;
function cwbCO_GetActiveEnvironment; stdcall; external cwbCO;

 const cwbRC='cwbRC.DLL'; 

function  cwbRC_AddParm; stdcall; external cwbRC;
function  cwbRC_CallPgm; stdcall; external cwbRC;
function  cwbRC_CreatePgm; stdcall; external cwbRC;
function  cwbRC_DeletePgm; stdcall; external cwbRC;
function  cwbRC_GetClientCCSID; stdcall; external cwbRC;
function  cwbRC_GetHostCCSID; stdcall; external cwbRC;
function  cwbRC_GetLibName; stdcall; external cwbRC;
function  cwbRC_GetParm; stdcall; external cwbRC;
function  cwbRC_GetParmCount; stdcall; external cwbRC;
function  cwbRC_GetPgmName; stdcall; external cwbRC;
function  cwbRC_GetSysName; stdcall; external cwbRC;
function  cwbRC_RunCmd; stdcall; external cwbRC;
function  cwbRC_SetLibName; stdcall; external cwbRC;
function  cwbRC_SetParm; stdcall; external cwbRC;
function  cwbRC_SetPgmName; stdcall; external cwbRC;
function  cwbRC_StartSys; stdcall; external cwbRC;
function  cwbRC_StopSys; stdcall; external cwbRC;

end.
