Unit EBCDIC;

(*
Copyright (C) 1998 Paul Toth (TothPaul@Mygale.org)
 http://www.mygale.org/~tothpaul

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*)



Interface

Uses
 SysUtils;

Procedure AnsiToEbcdic(var data;Size:integer);
Procedure EbcdicToAnsi(var data;Size:integer);

Procedure EbcdicToInt(var data;Size:integer);
Function  EbcdicUnpack(var data;PackSize,Size:integer):string;
Procedure Ebcdicpack(Value:string; var data;PackSize:integer);

Implementation

Const
 EBCDICTbl:array[0..255] of byte =(
$00,$01,$02,$03,$37,$2D,$2E,$2F,$16,$05,$25,$0B,$0C,$0D,$0E,$0F,$10,$11,$12,$13, { 20}
$B6,$B5,$32,$26,$18,$19,$1C,$27,$3F,$1D,$1E,$1F,$40,$5A,$7F,$7B,$5B,$6C,$50,$7D, { 40}
$4D,$5D,$5C,$4E,$6B,$60,$4B,$61,$F0,$F1,$F2,$F3,$F4,$F5,$F6,$F7,$F8,$F9,$7A,$5E, { 60}
$4C,$7E,$6E,$6F,$7C,$C1,$C2,$C3,$C4,$C5,$C6,$C7,$C8,$C9,$D1,$D2,$D3,$D4,$D5,$D6, { 80}
$D7,$D8,$D9,$E2,$E3,$E4,$E5,$E6,$E7,$E8,$E9,$BA,$E0,$BB,$B0,$6D,$79,$81,$82,$83, {100}
$84,$85,$86,$87,$88,$89,$91,$92,$93,$94,$95,$96,$97,$98,$99,$A2,$A3,$A4,$A5,$A6, {120}
$A7,$A8,$A9,$C0,$4F,$D0,$A1,$FF,$68,$DC,$6B,$07,$6B,$6D,$EA,$FA,$52,$6C,$E2,$4C, {140}
$D6,$58,$63,$67,$71,$79,$7D,$7F,$7F,$BD,$60,$6D,$DF,$EC,$A2,$6E,$96,$B2,$BF,$E8, {160}
$40,$AA,$4A,$B1,$0F,$B2,$6A,$B5,$7F,$83,$9A,$8A,$5F,$60,$99,$6D,$90,$8F,$EA,$F3, {180}
$7D,$A0,$B6,$B3,$6B,$F1,$9B,$8B,$B7,$B8,$6D,$AB,$C1,$C1,$C1,$C1,$63,$67,$9E,$68, {200}
$C5,$71,$C5,$C5,$C9,$C9,$C9,$C9,$C4,$69,$D6,$D6,$D6,$D6,$EC,$A7,$D6,$E4,$E4,$E4, {220}
$FC,$E8,$6D,$59,$44,$45,$42,$81,$43,$47,$9C,$48,$54,$51,$52,$53,$58,$55,$56,$57, {240}
$84,$49,$CD,$CE,$CB,$96,$CC,$E1,$96,$DD,$DE,$DB,$DC,$A8,$6D,$DF);                {256}

 ANSITbl:array[0..255] of byte =(
$00,$01,$02,$03,$5F,$09,$2B,$83,$2D,$5F,$2B,$0B,$0C,$0D,$0E,$A4,$10,$11,$12,$13, { 20}
$5F,$2B,$08,$2D,$18,$19,$2B,$5F,$1A,$1D,$1E,$1F,$2D,$A6,$2B,$2B,$2B,$0A,$17,$1B, { 40}
$A6,$2D,$2B,$5F,$5F,$05,$06,$07,$2D,$A6,$16,$2B,$2B,$2B,$A6,$04,$A6,$2D,$2B,$5F, { 60}
$5F,$5F,$5F,$1C,$20,$5F,$E2,$E4,$40,$E1,$E3,$E5,$5C,$F1,$B0,$2E,$3C,$28,$2B,$21, { 80}
$26,$7B,$EA,$EB,$7D,$ED,$EE,$EF,$EC,$DF,$A7,$24,$2A,$29,$3B,$5E,$2D,$2F,$C2,$C4, {100}
$C0,$C1,$C3,$C5,$C7,$D1,$F9,$2C,$25,$5F,$3E,$3F,$F8,$C9,$CA,$CB,$C8,$CD,$CE,$CF, {120}
$CC,$B5,$3A,$A3,$E0,$27,$3D,$22,$D8,$61,$62,$63,$64,$65,$66,$67,$68,$69,$AB,$BB, {140}
$F0,$FD,$FE,$B1,$5B,$6A,$6B,$6C,$6D,$6E,$6F,$70,$71,$72,$AA,$BA,$E6,$2C,$C6,$A4, {160}
$27,$22,$73,$74,$75,$76,$77,$78,$79,$7A,$A1,$BF,$D0,$DD,$DE,$AE,$A2,$23,$A5,$B7, {180}
$A9,$5D,$B6,$BC,$BD,$BE,$AC,$7C,$AF,$7E,$60,$D7,$E9,$41,$42,$43,$44,$45,$46,$47, {200}
$48,$49,$2D,$F4,$F6,$F2,$F3,$F5,$E8,$4A,$4B,$4C,$4D,$4E,$4F,$50,$51,$52,$B9,$FB, {220}
$FC,$7C,$FA,$FF,$E7,$F7,$53,$54,$55,$56,$57,$58,$59,$5A,$B2,$D4,$D6,$D2,$D3,$D5, {240}
$30,$31,$32,$33,$34,$35,$36,$37,$38,$39,$B3,$DB,$DC,$D9,$DA,$7F);                {256}

Type
 PByte=^AByte;
 AByte=Array[byte] of byte;

Procedure AnsiToEbcdic;
 var
  i:integer;
  databyte:PByte;
 begin
  databyte:=@data;
  for i:=0 to size-1 do databyte^[i]:=EbcdicTbl[databyte^[i]];
 end;

Procedure EbcdicToAnsi;
 var
  i:integer;
  databyte:PByte;
 begin
  databyte:=@data;
  for i:=0 to size-1 do databyte^[i]:=AnsiTbl[databyte^[i]];
 end;

Procedure EbcdicToInt;
 var
  i:integer;
  databyte:PByte;
 begin
  databyte:=@data;
  for i:=0 to size-1 do databyte^[i]:=databyte^[i] div 15 - 1;
 end;

Function EbcdicUnpack;
 Var
  i,j:integer; b:byte;
  databyte:PByte;
  high:boolean;
  zero:string;
 begin
  databyte:=@data;
  Result:=''; zero:='';
  j:=PackSize-1;
  high:=true;
  while Size>0 do begin
   dec(size);
   b:=databyte^[j];
   if high then begin b:=b shr 4; dec(j); end else b:=b and $F;
   high:=not high;
   if b=0 then
    zero:=zero+'0'
   else begin
    inc(b,ord('0'));
    if length(zero)>0 then begin
     Result:=Zero+Result;
     Zero:='';
    end;
    Result:=chr(b)+Result;
   end;
  end;
 end;

Procedure EbcdicPack;
 var
  i,j:integer; v,b:byte;
  databyte:PByte;
  high:boolean;
  size:integer;
 begin
  databyte:=@data;
  FillChar(databyte^,PackSize,0);
  v:=$F;
  j:=PackSize-1;
  high:=true;
  size:=length(value);
  while Size>0 do begin
   b:=ord(Value[Size])-ord('0'); dec(size);
   if high then begin
    databyte^[j]:=(b shl 4) or v;
    v:=0;
    dec(j);
   end else
    v:=b;
   high:=not high;
  end;
  if v>0 then databyte^[j]:=v;
 end;

end.
